import string
import re
import tempfile
from Lists import Lists
import os.path,os,time,sys

import profile,traceback

class DataFormater:

    relationName    = re.compile('\@RELATION\s+smipper\:(\S+)')
    attributeName   = re.compile('\@ATTRIBUTE\s+(\S+)')
    attributeValue  = re.compile('\@ATTRIBUTE\s+\S+\s+(\S+)')
    data            = re.compile('\@DATA')

    # attributes

    relations       = []


    def __init__(self, filename=None,binSize=10):
        if filename:
            number = self.addRelation(filename, binSize)
            
    def addRelation(self, filename=None,binSize=10):
        if filename:
            relNum = self.readArff(filename)
            #print "\n\nRelNum = %s\n" % relNum
            if self.getRelation(relNum):
                #print "do binning for RelNum = %s\n\n" % relNum
                self.getRelation(relNum).doBins(binSize)
                self.getRelation(relNum)._prepareLookUp()
               
            return relNum
        

    def readArff(self, filename):
        if filename:
            inF = open(filename,'r')
            data = inF.readlines()
            inF.close()
            relNum = len(self.relations)
            self.relations.append(self.convertArff(data))
            return relNum

    def convertArff(self, arffData):
        lines = arffData
        rel = relation()
        dataMode = 0
        for line in lines:
            if self.relationName.match(line):
                relName = self.relationName.findall(line)[0]
                rel.setName(relName)
            elif rel.nameSet():
                if self.attributeName.match(line) and self.attributeValue.match(line):
                    attName = self.attributeName.findall(line)[0]
                    attVal  = self.attributeValue.findall(line)[0]
                    rel.addAtt(attName, attVal)
                elif self.data.match(line):
                    dataMode = 1
                elif dataMode:
                    rel.addDataEntry(line)
                #else:
                #    print line

        return rel
        #rel.getData()
        #print rel.getValues(attribute='lumo',condition='class=active')

    def getCompoundsAsSmiles(self, condition='class=active', relNum=0):
        if self.relations[relNum]:
            smiles = self.relations[relNum].getValues(attribute='smiles',condition=condition)
            smilesIds = smiles.keys()
            smilesIds.sort()
            smilesData = []
            for k in smilesIds:
                smilesData.append(smiles[k]['smiles'])
            return smilesData
                


    # writes the input of the specialised ARFF file into a temp smiles file
    def writeCompoundsInTempSmilesFile(self, condition='class=active', relNum=0):
        if self.relations[relNum]:
            smilesData = string.join(self.getCompoundsAsSmiles(condition=condition, relNum=relNum),'\n')
            filename = self._getTempName()
            out = open(filename, 'w')
            out.writelines(smilesData)
            out.close()
            return filename

    def getRelation(self, relNum=0):
        if self.relations[relNum]:
            return self.relations[relNum]


    def _getTempName(self):
        return tempfile.mktemp('.smi')

    def __str__(self,selectedAttributes=[],selectedEntries={}):

        # selectedEntries should contain the entries with  SMIREP id, split into actives and inactives
        # selectedEntries = {'actives':[1,2,3,...],'inactives':[10,11,12,...]}

        returnString = 'UK'
        for rel in self.relations: 
            #rel = self.getRelation()

            relName = rel.getName()


            # get numerical ones first
            numAtts = rel.getNumericalAttributes()
            #get all other ones (just filter out the numerical and id and smiles (have to be there anyway))
            otherAtts = rel.getAttributes(numAtts+['id','class','smiles']) 
            allAtts = ['id']+otherAtts+numAtts+['smiles','class']
            returnString =  '@RELATION smipper:%s\n\n' % relName
            returnString +=  '@ATTRIBUTE id\t\tSTRING\n'
            for otherAtt in otherAtts:
                returnString +=  '@ATTRIBUTE %s\t\tSTRING\n' % otherAtt
            for numAtt in numAtts:
                returnString +=  '@ATTRIBUTE %s\t\tNUMERIC\n' % numAtt
            returnString +=  '@ATTRIBUTE smiles\t\tSTRING\n'
            returnString +=  '@ATTRIBUTE class\t\t{active,inactive}\n\n'
            returnString +=  '@DATA\n'
                
   
            
            activeData = {}
            inactiveData = {}
            
            print
            print selectedEntries
            print
            # if a selection of ids has been given, otherwise use all data 
            if (selectedEntries != {} and selectedEntries.has_key('actives') and selectedEntries.has_key('inactives')):
                print "selected"
                activesInternal = None
                inactivesInternal = None
                activesInternal = self.convertToInternalID(selectedEntries['actives'])
                inactivesInternal = self.convertToInternalID(selectedEntries['inactives'])
                activeData = dict(map(lambda x: (x,self.data[x]), activesInternal))
                inactiveData = dict(map(lambda x: (x,self.data[x]), inactivesInternal))
            else:
                activesInternal = rel.getIDs('active')
                inactivesInternal = rel.getIDs('inactive')
                activeData     =  dict(map(lambda x: (x, rel.getData()[x]), activesInternal.keys()))
                inactiveData   =  dict(map(lambda x: (x, rel.getData()[x]), inactivesInternal.keys()))

            for k in activeData.keys():
                activeData[k]['class'] = 'active'
            for k in inactiveData.keys():
                inactiveData[k]['class'] = 'inactive'
            

            actK = activeData.keys()
            inactK = inactiveData.keys()
            allKeys = actK+inactK
            allKeys.sort()

            valString = string.join(string.split(' %s'*len(allAtts),' '),', ')[2:]+'\n'
            for key in allKeys:
                values = []
                if key in actK:
                    values = map(lambda x: (activeData[key][x]),allAtts)
                else:
                    values = map(lambda x: (inactiveData[key][x]),allAtts)

                #print valString
                #print values
                #print allAtts
                dataLine = valString % tuple(values)
                returnString +=  dataLine
         
            #if !selectedAttributes:
            #    name = rel.getName()
                
        return returnString
        
class relation:

    li = Lists()
    getValuesHash = {}
    #getValuesHashCount = {}

    def setName(self, name=None):
        if name:
            self.name = name
        else:
            self.name       = None
        self.attributes = []
        self.data       = {}
        self.dataLen    = 0
        self.data_order = {}
        self.ids        = {'active':{},'inactive':{}}
        self.idsSMIP    = {'active':{},'inactive':{}}
        self.idsCount   = {'active':0,'inactive':0}
        self.bins       = {}
        self.temp       = {}
        
    def getName(self):
        return self.name

    def nameSet(self):
        return self.name

    def addAtt(self, attName=None, attVal=None):
        if attName and attVal:
            # print "#%s#\t#%s#" % (attName,attVal)
            if attName.lower() == 'id':
                self.id = attName
            if attVal.lower() == 'numeric':
                self.attributes.append((attName,'number',[]))
            elif attVal.lower() == 'string':
                self.attributes.append((attName,'string',[]))
            else:
                try:
                    attVal = attVal[attVal.index('{')+1:attVal.index('}')]
                except:
                    raise "Conversion error (%s,%s)" % (attName,attVal)
                vals  = map(lambda x: x.strip(),attVal.split(','))
                self.attributes.append((attName,'list',vals))
            
            #print self.attributes
            #self.data[attVal] = {}
            
    def getAttribute(self,smipperID,classification='active',attribute='cas'):


        selectedAtt = attribute
        labels = self.getAttributes([])

        #checks if the selected Attribute is in the lables, if not, either cas or id is chosen (per default)
        
        if selectedAtt not in labels:
            if 'cas' in labels:
                selectedAtt = 'cas'
            elif 'id' in labels:
                selectedAtt = 'id'
            
        returnVal = None
        try:
            intID = self.idsSMIP[classification][smipperID]
            returnVal = self.data[intID][selectedAtt]
        except:
            pass
        return returnVal

    def findID(self,externalID,classification='active'):
        ids = self.getIDs()
        for id in ids:
            if self.data[id]['id'] == externalID:
                smipperID = self.convertToSmipperID(self.data[id]['class'],[id])[0]
                return (id,smipperID,self.data[id]['class'])

        return None
            
            
    def getAttributes(self, filterList=['id', 'smiles']):
        retList = []
        attribs = map(lambda x:x[0],self.attributes)
        return filter(lambda x: x not in filterList, attribs)

    def getNumericalAttributes(self):
        retList = []
        attribs = map(lambda x:x[0],filter(lambda x: x[1]=='number',self.attributes))
        return attribs

    def getData(self):
        return self.data

    def printHashUsage(self):
        seKeys = self.getValuesHashCount.values()
        seKeys.sort()
        seKeys.reverse()
        print seKeys[:100]

    def getCalues(self,attribute, condition,ids,internalId):
        #akprint = "%s;%s;%s;%s" % (ids,condition,attribute,internalId)
        #print "condition ",condition
        #if self.getValuesHash.has_key(akprint):
        #    self.getValuesHashCount[akprint] += 1
        #    return self.getValuesHash[akprint]
        #else:
        #    self.getValuesHashCount[akprint] = 0
            
        (con,value) = condition
        potentials = []
        try:
            potentials = self.lookUp[internalId][attribute][value][con]
        except:
            raise "Problem"

        #print "potentials ",potentials
        interSec = self.li.intersection(ids,potentials)
        #interSec2 = self.li.intersectionO(ids,potentials)
        #self.getValuesHash[akprint] = interSec2
        return interSec
  

    def getBalues(self, attribute=None, ids=None, internalId=None):
        #akprint = "%s#%s#%s" % (attribute, ids, internalId)
        #if self.getValuesHash.has_key(akprint):
        #    return  self.getValuesHash[akprint]
        retList = self.data
        if ids is not None and internalId:
            idInternal = self.convertToInternalID(internalId,ids)
            retListT = dict(zip(idInternal,map (lambda x: retList[x],idInternal)))
            retList = retListT

            if attribute:
                retListT = dict(map(lambda x: (x[0],{attribute:x[1][attribute]}),map(lambda x: (x,retList[x]), retList)))
                retList = retListT

            rt1 =  retList.keys()
            rt1.sort()

            # convert back to SMIPPER IDs
            #retListT = dict(map(lambda x: (self.ids[internalId][x],retList[x]) ,retList))
            #self.getValuesHash[akprint] = retList
            return retList
                
    
    def getValues(self, attribute=None, condition=None,id=None, internalId=None):
        #akprint = "%s %s %s %s" % (attribute, id, internalId)
        #if self.getValuesHash.has_key(akprint):
        #    return  self.getValuesHash[akprint]
        #print "## getValues %s"  % akprint
        retList = self.data
        if id is not None and internalId:
            if self.temp.has_key(internalId):
                
                retList = self.temp[internalId]
            else:
                #print "RELATION condition='class=%s' " % (internalId)
                retList = self.getValues( condition='class=%s' % (internalId))
                self.temp[internalId] = retList
                #print "RELATION FINISHED"
                #rL = self.temp[internalId].keys()
                #rL.sort()
                #print rL
                
            if type(id) is type([]):
                #ids = map(lambda x: x in a,range(len(retList.keys())))
                #print "%s\t\t%s" % (id,internalId)
                #print 'in if type id = []'
                idInternal = self.convertToInternalID(internalId,id)
                #ids = map(lambda x: (x+1) in id,range(len(retList.keys())))
                #ids = map(lambda x: (x+1) in id,range(len(retList.keys())))
                #retList = dict(map(lambda x: (x[1],retList[x[1]]), filter(lambda x: x[0],zip(ids,retList))))
                retListT = dict(zip(idInternal,map (lambda x: retList[x],idInternal)))
                retList = retListT
                rtK =  retList.keys()
                rtK.sort()
                #print "retList = %s" % rtK
            else:
                key = retList.keys()[id-1]
                retList = {key:retList[key]}

        
        if condition:
            (conAtt,conVal) = condition.split('=')
            retList = dict(filter(lambda x: x[1][conAtt]==conVal,map(lambda x: (x,retList[x]), retList)))

        if attribute and attribute in self.getAttributes(filterList=[]):
            #print "%s" % (map(lambda x: (x[0],x[1][attribute]),map(lambda x: (x,retList[x]), retList)))
            retList = dict(map(lambda x: (x[0],{attribute:x[1][attribute]}),map(lambda x: (x,retList[x]), retList)))

        #print "retList=%s" % retList
        #self.getValuesHash[akprint] = retList
        return retList


    def getValue(self,attribute,classification,id):
        valDict =  self.getValues(attribute,id=id,internalId=classification)
        return map(lambda x: valDict[x][attribute], valDict.keys())[0]

    def getBinAttribute(self,attribute, value):
        #print "## getBinAttribute %s %s" % (attribute, value)
        bins = self.getBins( attribute)
        binsAbove = filter(lambda x : value <= x, bins)
        binsBelow = filter(lambda x : value > x, bins)
        binsSAbove = map(lambda x: '%s:#X# <= %s' % (attribute,x), binsAbove)
        binsSBelow = map(lambda x: '%s:#X# > %s' % (attribute,x), binsBelow)
        return binsSBelow+binsSAbove
        
    def getBins(self,attribute):
        if attribute in self.bins.keys():
            return self.bins[attribute]

    def doBins(self, size=10):
        for att in self.getNumericalAttributes():
            #print "att = %s\n" % att
            self.binning(att,size)

    def binning(self,attribute,size=10):
        print 'binning: %s:%s' % (attribute,size)
        if attribute in self.getNumericalAttributes():
            values = self.getValues(attribute=attribute)
            vals = map (lambda x: values[x][attribute], values.keys())
            vals.sort()
            # if size > 0 then do real binning , if not use all possible numerical values
            if size > 0 :
                self.bins[attribute] = self._binning(vals,size)
                #if attribute == 'molweight':
                #    #self.bins[attribute] = [145.75396,197.39512,249.03628,300.67744,352.3186,403.95976,455.60092,507.24208,558.88324]
                #    self.bins[attribute] = [197.39512,300.67744,403.95976,507.24208]
                #if attribute == 'logpe':
                #    #self.bins[attribute] = [-0.835,0.33,1.495,2.66,3.825,4.99,6.155,7.32,8.485]
                #    self.bins[attribute] = [0.33,2.66,4.99,7.32]
            else:
                sortedVals = self.li.uniq(vals)
                sortedVals.sort()
                self.bins[attribute] = sortedVals
            #print self.bins[attribute]
            
    def _binning(self,vals, size=10):
        #print '_binning'
        if vals:
            bSize        = len(vals)*1.0/size
            borders      = []
            bins         = 0
            currentBin   = 1
            last         = vals[0]-1
            numBinned    = 1
            binNumber    = 1
            for i in range(len(vals)):
                #print "%s\t%s\t%s\t%s" % (len(borders),currentBin,vals[i], last)
                #if (currentBin < bSize) or (vals[i] == last):
                if (numBinned < bSize*binNumber) or (vals[i] == last):
                    last = vals[i]
                    currentBin += 1
                    numBinned += 1
                else:
                    #print numBinned, currentBin, last
                    borders.append(last)
                    currentBin = 0
                    binNumber += 1

            #print numBinned, currentBin, last
            #borders = borders[1:]
            #borders = [145.7538, 197.3946, 249.0354, 300.6762, 352.317, 403.9578, 455.5986, 507.2394, 558.8802]
            #print borders
            #print len(borders)
            return borders

      
    def addDataEntry(self,dataEntryString=None):
        #print dataEntryString
        dataEntryString = dataEntryString.strip()
        if dataEntryString:
            entryS = dataEntryString.strip()
            valList = []
            try:
                valList = entryS.split(',')
            except:
                raise 'data conversion problems'

            tempSet = {}
            tempId  = None
            attributes = self.attributes
            #print attributes
            for num in range(len(attributes)):
                #print dataEntryString
                #print num
                newVal = self._checkAttVal(attributes[num],valList[num])
                    
                tempSet[attributes[num][0]] = newVal
                #if attributes[num][0] != 'id':
                #    tempSet[attributes[num][0]] = newVal
                #else:
                #    tempId = newVal
            if tempSet:
                i = self.dataLen
                self.data[i] = tempSet
                #print tempSet
                self.idsCount[tempSet['class']] += 1
                self.ids[tempSet['class']][i] = self.idsCount[tempSet['class']]
                self.idsSMIP[tempSet['class']][self.idsCount[tempSet['class']]] = i
                if tempId:
                    print "tempId", tempId
                    #self.ids.append(tempId)
                self.dataLen += 1
            

    def _checkAttVal(self, attribute, val):
        val = val.strip()
        if attribute[1] == 'string':
            return '%s' % val
        elif attribute[1] == 'number':
            retVal = None
            try:
                retVal = string.atof(val)
            except:
                raise 'could not convert (%s,%s) to number!' % (attribute,val)
            return retVal
        elif attribute[1] == 'list':
            if val in attribute[2]:
                return val
            else:
                raise 'attribue (val=%s) is not in list(%s)' % (val,attribute[2])
        return None

    def getIDs(self,classi=None):
        if classi:
            try:
                return self.ids[classi]
            except:
                raise "Not such class"
        else:
            retIDs = []
            for key in self.ids.keys():
                retIDs += self.ids[key]
            return retIDs
        
    def convertToSmipperID(self, classification, ids=[]):
        if ids and classification:
            retList = map(lambda x: self.ids[classification][x],ids)
            return retList
            retDict = {}
            count = 0
            for id in ids:
                retDict[count] = None
                try:
                    retDict[count] = self.ids[classification][id]
                except:
                    print count, classification, id, ids
                    raise "Excpet"
                count += 1
            return retDict.values()
        
    def convertToInternalID(self, classification, ids=[]):
        #print "classification = %s" % classification
        #print "ids = %s" % len(ids)
        if ids == []:
            return []
        
        if ids and classification:
            retList = map(lambda x: self.idsSMIP[classification][x],ids)
            return retList

        return 
        posibleIDs =  self.ids[classification].keys()
        posibleIDs.sort()
        #print self.ids[classification]
        #print self.idsSMIP[classification]
        #print '*'*80
        if ids and classification:
            retDict = {}
            count = 0
            for id in ids:
                #print "\nID %s" % id
                retDict[count] = None
                try:
                    retDict[count] = self.idsSMIP[classification][id]
                except:
                    print count, classification, id, ids
                    raise "Excpet"
                count += 1
            return retDict.values()
        
            
    def _prepareLookUp(self):

        #print "_prepareLookUp"
        self.lookUp = {}

        #get data only for actives inactive (in form of dictionary)
        
        activeData     =  dict(map(lambda x: (x,self.data[x]), self.ids['active'].keys()))
        inactiveData   =  dict(map(lambda x: (x,self.data[x]), self.ids['inactive'].keys()))


        self.lookUp['active'] = {}
        self.lookUp['inactive'] = {}
        
        #for attribute in self.getNumericalAttributes():
        for attribute in self.getNumericalAttributes():
            #print "preparing %s" % attribute
            # create new dict containing only one attribute/value
            self.lookUp['active'][attribute] = {}
            self.lookUp['inactive'][attribute] = {}
            
            tempA = dict(map(lambda x: (x,activeData[x][attribute]) ,activeData.keys()))
            tempI = dict(map(lambda x: (x,inactiveData[x][attribute]) ,inactiveData.keys()))

            #print tempA

            bins = self.getBins(attribute)
            #print bins

           
            for bin in bins:

                binString = "%s" % bin
                #print bin, binString
                self.lookUp['active'][attribute][binString] = {}
                self.lookUp['inactive'][attribute][binString] = {}
                
                tempALE = filter(lambda x: tempA[x]<=bin,activeData.keys())
                tempAG = filter(lambda x: tempA[x]>bin,activeData.keys())
                tempILE = filter(lambda x: tempI[x]<=bin,inactiveData.keys())
                tempIG = filter(lambda x: tempI[x]>bin,inactiveData.keys())
                #print len(tempALE),len(tempAG),(len(tempALE)+len(tempAG)),"\t",len(tempILE),len(tempIG),(len(tempILE)+len(tempIG))
                self.lookUp['active'][attribute][binString]['>'] = self.convertToSmipperID('active',tempAG)
                self.lookUp['active'][attribute][binString]['<='] = self.convertToSmipperID('active',tempALE)
                self.lookUp['inactive'][attribute][binString]['>'] = self.convertToSmipperID('inactive',tempIG)
                self.lookUp['inactive'][attribute][binString]['<='] = self.convertToSmipperID('inactive',tempILE)

        

    def __str__(self):
        """ for printing """
        retString = ""
        retString += 'Name: %s\n' % (self.name)
        retString += '-'*80
        retString += '\nnum\t'
        attNames = map(lambda x: x[0],self.attributes)
        for att in attNames:
            retString += '%s\t' % att
        retString += '\n'
        retString += '-'*80
        retString += '\n'

        dataKeys = self.data.keys()
        for k in dataKeys:
            retString += '%s\t' % k
            for att in attNames:
                retString += '%s\t' % self.data[k][att]
            retString += '\n'
        return retString
        

def main():
    DF = Dataformater('./data/muta/188.arff',0)
    #DF = Dataformater('./data/cpdb/mutagen.arff',0)
    rel = DF.getRelation(0)

    #print rel.getIDs()
    #print rel.findID('d1')
    #sys.exit(0)

    aids = rel.convertToSmipperID('active',rel.getIDs('active'))
    iids = rel.convertToSmipperID('inactive',rel.getIDs('inactive'))
    #for i in aids:
    for i in range(125):
        name =  rel.getAttribute(i+1,'active')
        #print "%s %s %s" % (i+1,name,rel.findID(name))
        print "%s" % (name)
    #for i in iids:
    for i in range(63):
        name =  rel.getAttribute(i+1,'inactive')
    #    print "%s %s %s" % (i+1,name,rel.findID(name))
        print "%s" % (name)
        
    sys.exit(0)

    aids = rel.convertToSmipperID('active',rel.getIDs('active'))
    iids = rel.convertToSmipperID('inactive',rel.getIDs('inactive'))


    li = Lists()

    labels = rel.getNumericalAttributes()
    for i in range(2000):
        for label in labels:
            numVal = li.randList(rel.getBins(label),1)[0]
            #print "%s" % numVal
            rel.getCalues(label,('>',"%s" % numVal),li.randList(aids,50),'active')
        if i % 50 == 0:
            time.sleep(0.5)
            

    
    #print rel.getNumericalAttributes()
    #rel._prepareLookUp()
    #bins = rel.getBins('logp')
    #print len(bins);

    #DF.readArff('./data/fhm/perl/fhm_reactive.arff')
    #DF.readArff('./data/cpdb/mutagen.arff')
    #print DF.getRelation(0)

if __name__=='__main__':
    main()
    
