import re, string, sys, math, os
from sets import Set

import random

class Lists:

    intersectionHash = {}
    
    def copy(self, list):
        returnList = []
        for e in list:
            returnList.append(e)
        return returnList

    def subtract(self, list1, list2):
        list_dict = {}
        for e in list1:
            list_dict[e] = 1
        for e in list2:
            if list_dict.has_key(e):
                list_dict[e] = 2
            else:
                list_dict[e] = 3
        return filter(lambda x: list_dict[x] == 1, list_dict.keys())
    

    def diff(self,list1,list2):
        d1 = filter(lambda x: x not in list1,list2)
        d2 = filter(lambda x: x not in list2,list1)

        return d2+d1

    def notIn(self,list1,list2):
        d1 = filter(lambda x: x not in list1,list2)
        
        return d1

    def element(self,element,list):
        for e in list:
            if e == element:
                return 1
        return 0

    def elementSorted(self,element,sortedList):

        length = len(sortedList)
        #print 'elementSorted1',length
        if length<=10:
            if element in sortedList:
                #print 'elementSorted2',sortedList
                return 1
            else:
                #print 'elementSorted3',sortedList
                return 0
        middle = length/2
        if element <= sortedList[middle]:
            return self.elementSorted(element,sortedList[:middle+1])
        else:
            return self.elementSorted(element,sortedList[middle:])
 
    # intersection using set seems to be faster
    def intersection(self, list1, list2):

        set1 = Set(list1)
        set2 = Set(list2)
        retSet = set1 & set2
        retList = retSet._data.keys()
        #self.intersectionHash[hass] = retList
        return retList

    def intersectionO(self, list1, list2):
        if type(list1) != type([]) or type(list1) != type([]):
            raise "Cannot find intersection of non-lists (%s,%s)" % (type(list1), type(list2))
        if not list1 or not list2:
            return []

        list1.sort()
        list2.sort()
        hass = '%s###%s' % (list1,list2)
        try:
            return self.intersectionHash[hass]
        except:
            pass
        int_dict = {}
        list1_dict = {}
        for e in list1:
            list1_dict[e] = 1
        for e in list2:
            try:
                int_dict[e] = list1_dict[e]
            except:
                pass
            #if list1_dict.has_key(e):
            #    int_dict[e] = 1
        retList = int_dict.keys()
        retList.sort()
        self.intersectionHash[hass] = retList
        return retList

    # union using set seems to be slower
    def unionN(self, list1, list2):
        set1 = Set(list1)
        set2 = Set(list2)
        retSet = set1 | set2
        retList =  retSet._data.keys()
        retList.sort()
        return retList
        
    def union(self, list1, list2):
        union_dict = {}
        for e in list1:
            union_dict[e] = 1
        for e in list2:
            union_dict[e] = 1
        retList = union_dict.keys()
        #retList.sort()
        return retList

    #returns 1 if listA is a subList of listB
    # very lazy implementation could be done better with b.index(a[])...
    def isSubList(self, listA, listB):
        isSubList  = 1
        for el in listA:
            if not el in listB:
                isSubList = 0
                break
        return isSubList

    def uniq(self, list):
        if type(list)==type([]) and list != []:
            ele = list[0]
            if type(ele) != type('s') and type(ele) != type(1) and type(ele) != type(5.0):
                return self.uniq_complex(list)
            else:
                return self.uniq_simple(list)
        return []

    # for simple lists:
    def uniq_simple(self,list):
        union_dict = {}
        for e in list:
            union_dict[e] = 1
        return union_dict.keys()

           
    # for complex lists:
    def uniq_complex(self,list):
        retList = []
        for e in list:
            if e not in retList:
                retList.append(e)
        return retList
           

    def randList(self, aList, number):
        #random.seed(20)
        randA = {}
        randL = []
        lenList = len(aList)
        if lenList > number:
            while len(randA)<number :
                i = random.randrange(0,lenList)
                randA[i] = 1
            helperList = randA.keys()
            for helperEle in  helperList:
                randL.append(aList[helperEle])
            return randL
        elif lenList == number:
            random.shuffle(aList)
            return aList
        return None

    def join(self,lists):
        joinedList = []
        if lists:
            for list in lists:
                joinedList = joinedList+list
            return joinedList


    def splitIntoKRandom(self, aList, k):

        lists = []
        if aList and k:
            lenList = len(aList)
            if lenList < k:
                return [aList]
            else:
                kSize = int(lenList*1.0/k)
                tempList = self.copy(aList)
                for i in range(k-1):
                    tList = self.randList(tempList,kSize)
                    lists.append(tList)
                    tempList = self.subtract(tempList, tList)
                lists.append(tempList)
                return lists
