import re, string, sys, math, os
import random
import time
import getopt
import profile
import traceback

from Timer import Timer
import OBGrep
from DataFormater import DataFormater
from Matcher import Matcher
from Lists import *

#from Memory import *

def mySort(x,y):
    if x[0] < y[0]:
        return -1
    elif x[0] == y[0]:
        return 0
    else:
        return 1

def isNum(o):
    tp = type(o)
    if tp is type(5) or tp is type(5.0):
        return 1
    else:
        return 0

# sorting for new rule structures, sorts first by score(descending), then by length of number of conjunctions(ascending)
def sortRules(a, b):
    cmpR = cmpRule(a ,b)
    return cmpR

def cmpRule(a ,b):
    if type(a) == type([1,]):
        raise "Type error rule was empty List (A)"
    if type(b) == type([1,]):
        raise "Type error rule was empty List (B)"
    if a==b:
        return 0
    if not b:
        return 1
    elif not a:
        return -1
    score = cmp(b['score'], a['score'])
    if score:
        return score
    posL = cmp(len(b['matchingA']),len(a['matchingA']))
    if posL:
        return posL
    fragmentsLen = cmp(len(a['fragments']), len(b['fragments']))
    if fragmentsLen:
        return fragmentsLen
    
   
    return 0
    if a['fragments']==b['fragments']:
        print a
        print b
        return 0
    else:
        
        return 1
        
def cmpRuleFull(a ,b):

    for key in ['score','history','patterns','matchingA','matchingI']:
        retScore = cmp(b[key], a[key])
        if retScore:
            return retScore
    return 0

        
     
    
    
    
    


class Node:

    data       = None
    start      = None
    end        = None
    label      = 'u' # for undefined
    parent     = None
    matchList  = None
    children   = None
    eva        = None
    numerical  = 0

    def __init__(self,data=None,parent=None, start=None, end=None, matchList=None):
        self.setParent(parent)
        self.setData(data)
        self.setMatchList(matchList)
        self.setStart(start)
        self.setEnd (end)
        self.eva = {}
        self.frag = None

    def setParent(self,parent=None):
        if parent:
            self.parent = parent
    def getParent(self):
        return self.parent
    
    def setData(self,data=None):
        if data:
            self.data = data
    def getData(self):
        return self.data

    def setFrag(self,frag):
        if frag:
            self.frag = frag
    def getFrag(self):
        return self.frag

    def setNumerical(self):
        self.numerical = 1
    def unsetNumerical(self):
        self.numerical = 0
    def isNumerical(self):
        return self.numerical

    def setStart(self,start=None):
        if start is not None and start>= 0:
            self.start = start
        else:
            raise "Start not allowed %s %s" %  (start, self)
            self.start = 0
            
    def getStart(self):
        return self.start

    def setEnd(self,end=None):
        if end and end>= 0:
            self.end = end
    def getEnd(self):
        return self.end

    def getNumLabel(self):
        label = self.getLabel()
        atoi = None
        try:
            atoi = string.atoi(label)
        except:
            pass
        return atoi

    def getOtherData(self, mode):
        isNum = 0
        try:
            num = string.atoi(self.getLabel())
            isNum = 1
        except:
            pass
        if isNum:
            parData = self.getParent().getData()
            other = None
            if self.getStart() is None:
                print 'self = %s' % (self)
                print 'parent = %s' % (self.getParent())
            if mode=='left':
                other = parData[:self.getStart()]
            elif mode=='right':
                other = parData[self.getEnd():]
            return other
        else:
            return None    
    
    def setData(self,data=None):
        if data:
            self.data = data
    def getData(self):
        return self.data
   
    def setMatchList(self,matchList=None):
        if matchList:
            self.matchList = matchList
    def getMatchList(self):
        return self.matchList

    def getMatchCount(self):
        if self.matchList:
            return len(self.matchList)
        return None

    def setLabel(self, label=None):
        if label:
            self.label = label
        else:
            print self.getData()
            sys.exit(0)
            
    def getLabel(self):
        return self.label

    def getKidLabel(self, label):
        if label:
            if self.hasChildren():
                kids = self.getChildren()
                res = filter (lambda x: x[0]==label, kids)
                if res:
                    return res[0][1]
        return None
    
    def addChild(self,child=None, label=None):
        if child:
            if label:
                if not self.children:
                    self.children = {}
                self.children[label] = child
                child.setLabel(label)
            else:
                self.children.append(child)

    def getChildren(self):
        if self.children:
           if type(self.children) == type([]):
               return map(lambda x: (x,self.children[x]), range(len(self.children)))
           else: # hash
               return map(lambda x: (x,self.children[x]), self.children.keys())
        return None

    def hasChildren(self):
        if self.children:
            return 1
        else:
            return 0

    def getLeaves(self):
        retList = []
        if self.hasChildren():
            kids = self.getChildren()
            for (label, kid) in kids:
                retList = retList + kid.getLeaves()
            return retList
        else:
            return [self]


    def setEvaluation(self, type, subType, rule, converged, score, start, end):
        evalKey = '%s_%s' % (type,subType)
        if not self.eva.has_key(evalKey):
            self.eva[evalKey] = {'rule':rule, 'converged':converged, 'score':score, 'start':start, 'end':end}

    def getEvaluation(self, type, subType):
        evalKey = '%s_%s' % (type,subType)
        if self.eva.has_key(evalKey):
            evaL = self.eva[evalKey]
            return (evaL['rule'],evaL['converged'],evaL['score'],evaL['start'],evaL['end'])
        else:
            return None


    def toXML(self, depth=0,rootLabel='root'):
        retString = ''
        if depth == 0:
            return (('<%s>\n'% (rootLabel))+self.toXML(depth=1)+'</%s>\n' % (rootLabel))
        kids = self.getChildren()
        if kids:
            retString = '\t'*depth + '<%s> # %s' % (self.getData(),self.getLabel())+'\n'
            kids.sort(mySort)
            for (label,kid) in kids:
                retString = retString + kid.toXML(depth+1)
            retString = retString+ '\t'*depth + '</%s>' % ('aNode')+'\n'
        else:
            retString = '\t'*depth + '<%s/> # %s' % (self.getData(), self.getLabel())+'\n'
        return retString

    def toPlain(self, depth=0):
        retString = '\t'*depth + '%s\t%s' % (self.getLabel(),self.getData())+'\n'
        kids = self.getChildren()
        if kids:
            kids.sort(mySort)
            for (label,kid) in kids:
                retString = retString + kid.toPlain(depth+1)

        return retString

    def getAllPatterns(self):
        retList = ['%s' % self.getData()]
        #print ">> %s" % self.getData()
        kids = self.getChildren()
        if kids:
            kids.sort(mySort)
            for (label,kid) in kids:
                retList = retList + kid.getAllPatterns()
        return retList
       
    def getAllNodes(self):
        retList = [self]
        #print ">> %s" % self.getData()
        kids = self.getChildren()
        if kids:
            kids.sort(mySort)
            for (label,kid) in kids:
                retList = retList + kid.getAllNodes()
        return retList

    def getRoot(self):
        parent = self.getParent()
        if not parent:
            return self
        return parent.getRoot()

    def __del__(self):
        kids = self.getChildren()
        if kids:
            for (label,kid) in kids:
                kid.__del__()
                del kid
        if self.data:
            del self.data 
        if self.start:
            del self.start
        if self.end:
            del self.end
        if self.parent:
            del self.parent
        if self.matchList:
            #for item in self.matchList:
            #    self.matchList.remove(item)
            #    del item
            del self.matchList
        if self.label:
            self.label = ''
            del self.label 
        if self.eva:
            del self.eva 
        if self.numerical:
            del self.numerical
        if self.frag:
            del self.frag
        if self.children:
            del self.children
        del self
    
class functionalGroups:

    def __init__(self):
        entryNames = []
        entryNodes = []
        fileName = 'functionalGroups.tab'
        fn = open(fileName,'r')
        data = fn.readlines()
        fn.close()
        for entry in data:
            (num,smart,desc) = entry.split('\t')
            entryNames.append(smart)
            newNode = Node(smart,start=0)
            entryNodes.append(newNode)
            
        self.entryNames = entryNames
        self.entryNodes = entryNodes


    def getNodes(self):
        return self.entryNodes
            
       


class SMIREP:

    # reg exp
    simplePar    = re.compile('\([\w|\=|\d|\[|\]|\+|\-|\=|\:|\*|\.]+\)')
    oElements    = re.compile('\[\S+?\]')
    plainNum     = re.compile('((?:[\d|\%\d+]))')
    numbers      = re.compile('((?:\w|\[[a-zA-Z|\d|\+|\-]*\])[\-|\=|\:|\#]{0,1})(\d+)') # is in principle right, but must be made strict (lookup at python.org/re)
    numbers      = re.compile('((?:[a-zA-Z]|\[[a-zA-Z\-\+\d]*?\])[\-|\=|\:|\#]?)(\d+)') # is in principle right, but must be made strict (lookup at python.org/re)
    # {} uniqNums      = re.compile('(?:uniqNum\w{3,3}\*(\d+)\*')
    uniqNums     = re.compile('(?:\{|\})\*(\d+)\*')
    nextElement  = re.compile('(\w|\[.+\])')
    # also oldanElement    = re.compile('(\(*[\-|\=|\:|\#]{0,1}(?:uniqNum\w{3,3}\*\d+\*(?:[a-tv-zA-TV-Z]|\[\S+\])|uniqNum\w{3,3}\*\d+\*|\w|\[\S+\])\)*)')

    #before {} anElement    = re.compile('(\(*[\-|\=|\:|\#]{0,1}(?:uniqNumSta\*\d+\*(?:[a-tv-zA-TV-Z]|\[\S+\])|(?:[a-tv-zA-TV-Z]|\[\S+\])uniqNumEnd\*\d+\*|\w|\[\S+\])\)*)')
    
    #anElement    = re.compile('(\(*[\-|\=|\:|\#]{0,1}(?:\{\*\d+\*(?:[a-tv-zA-TV-Z]|\[\S+\])|(?:[a-tv-zA-TV-Z]|\[\S+\])\}\*\d+\*|\w|\[\S+\])\)*)')
    #anElement     = re.compile('((?:\{\*\d+\*(?:\w|\[\S+\])|(?:\w|\[\S+\])(?:\}\*\d+\*)+)|(?:\w|\[\S+\]))')
    #anElement     = re.compile('(\(?(?:(?:\{\*\d+\*)+[\-|\=|\:|\#]{0,1}(?:\w|\[\S+?\])|(?:\-|\=|\:|\#){0,1}(?:\w|\[\S+\])(?:\}\*\d+\*)+)|(?:\-|\=|\:|\#){0,1}(?:\w|\[\S+\])\)?)')
    anElement     = re.compile('(\(?(?:(?:\{\*\d+\*)+[\-|\=|\:|\#]{0,1}(?:\w|\[\S+?\])|(?:\-|\=|\:|\#){0,1}(?:\w|\[\S+?\])(?:\}\*\d+\*)+)|(?:\-|\=|\:|\#){0,1}(?:\w|\[\S+?\])\)?)')

    inBrackets = re.compile('\(([a-tv-zA-TV-Z\-\=\:\#\*\d\/\$\}\{]+)\)')

    # attributes
    matcher = None
    minPos  = None
    maxNeg  = None
    binSize = None

    rocFileName = None
    ruleDirectory = None

    heuristics = {}
    useHeuristicName = None
    useHeuristicFunction = None

    outputFile     = None
    outputFileName = None
    relation       = None
    relationLoaded = None
    verbosityLevel = 0
    

    #counters
    splitIntoElementsCounter = 0
    splitIntoElementsBuffer = {}

    degradeBeam = 0

    globalFrags = []
    globalFragsUsed = []
    
    li = Lists()
    
    def  __init__(self, matcher = None):
        if matcher:
            self.setMatcher(matcher)
        self.registerHeuristics()
        #self.fg = functionalGroups()

    def openOutputFile(self, outFilename=None):
        if outFilename:
            self.outputFile = open(outFilename,'w')

    def getOutputFile(self):
        return self.outputFile
            
    def closeOutputFile(self):
        self.outputFile.close()
        
    def convertBackToSmiles(self,convertedSmilesString):
        if convertedSmilesString != '':
            workString = self.cleanNumberElements(convertedSmilesString)
            if workString != '':
                workString = workString.replace('**','') # replace inserted ** (used for num of H)
                #print '2',workString
                if workString[0] == ')':
                    workString = workString[1:]
                if workString[0] in ['(','=','-',':','#']:
                    workString = '*'+workString
                if workString[len(workString)-1] in ['=','-',':','#'] :
                    workString = workString+'*'
                resultString = self.removeUnbalancedMode(workString,'right')
                return resultString
            else:
                return ''
        
        return None
        
    def cleanNumberElements(self,convertedSmilesString):
        workString = convertedSmilesString
        uniqNumList   = []
        doubleNumList = []
        numAllsString = self.uniqNums.findall(workString)
        numAlls       = map(lambda x: string.atoi(x), numAllsString) # convert to interger list
        
        rH = reHelper()
        uniqNumList = rH.getUniques(numAlls)
        doubleNumList = rH.getDoubles(numAlls)


        # remove unused opening or closing numbers
        for uNum in uniqNumList:
            numAlls.remove(uNum) # removed uNum from the list of all numbers
            match = re.search('(?:\{|\})\*%s\*' % uNum, workString)
            workString = workString.replace(match.group(),'')

        # renumber the links according to SMILES/SMARTS 
        usedSmilesNumbers = {}
        maxSmilesNumber = 0

        lookup = {}
        
        for num in numAlls:
            useNum = None
            # first case: number is in use:
            for i in range(maxSmilesNumber+1)[1:]:
                if usedSmilesNumbers[i] == num: # number in use (this must be the closing one)
                    useNum = i
                    usedSmilesNumbers[i] = None # this one is empty again
                    break
            # second case: find a number which is not used at the moment. Use this one
            if not useNum:
                for i in range(maxSmilesNumber)[1:]: 
                    if not usedSmilesNumbers[i]!=None: #this number is available, use this one
                        useNum = i
                        usedSmilesNumbers[i] = num
                        lookup[num] = useNum
                        break
                    # third case couldn't find a number either in use or free, insert a new one
                if not useNum:
                    maxSmilesNumber += 1
                    useNum = maxSmilesNumber
                    usedSmilesNumbers[useNum] = num
                    lookup[num] = useNum
                    

        matchList = re.findall('(?<=\{\*\d\*)(\{\*\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
        matchList = matchList + re.findall('(?<=\{\*\d\d\*)(\{\*\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
        matchList = matchList + re.findall('(?<=\{\*\d\*)(\{\*\d\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
        matchList = matchList + re.findall('(?<=\{\*\d\d\*)(\{\*\d\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
        #print "clean:matchList1",matchList 
        while(matchList):
            for match in matchList:
                oldString = match[0]+match[1]
                newString = match[1]+match[0].replace('{*', '{#*')
                workString = workString.replace(oldString, newString)
                # do all possibilities as a lookbehind '(?<)' doesn't allow \d+
                matchList = re.findall('(?<=\{\*\d\*)(\{\*\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
                matchList = matchList + re.findall('(?<=\{\*\d\d\*)(\{\*\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
                matchList = matchList + re.findall('(?<=\{\*\d\*)(\{\*\d\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
                matchList = matchList + re.findall('(?<=\{\*\d\d\*)(\{\*\d\d\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
                
        matchList = re.findall('(\{\*\d+\*)((?:\[\S+?\]|[a-tv-zA-Z]{0,1}))', workString)
        #print "clean:matchList2",matchList 
        for match in matchList:
            oldString = match[0]+match[1]
            newString = match[1]+match[0]
            workString = workString.replace(oldString, newString)

        workString = workString.replace('{#*', '{*')

        #print "clean:workString", workString
        for num in lookup.keys():
            workString = workString.replace('{*%s*' % num, '%s' % lookup[num])
            workString = workString.replace('}*%s*' % num, '%s' % lookup[num])

        #print "clean:workString", workString
                

        return workString
    
    def markOtherElementsCharge(self, smilesString):
        workString = smilesString
        # change numbers in other elements (within []) to special
        offsetL = 0
        offsetG = 0
        match =  self.oElements.search(workString)
        while(match):
            tempString = workString[match.start():match.end()]
            num = self.plainNum.search(tempString)
            while(num):
                tempStringNew = tempString[:num.start()]+'**'+num.group()+'**'+tempString[num.end():]
                tempString = tempStringNew
                offsetL = num.end()+3
                num = self.plainNum.search(tempString, offsetL)
            workString = workString[:match.start()]+tempString+workString[match.end():]
            offsetG = match.start()+len(tempString)
            match = self.oElements.search(workString, offsetG)
        return workString

    def isolateElements(self, workString):

        change = ['Cl', 'Br']

        for el in change:
            workString = workString.replace(el, '['+el+']')
        return workString

    def renumberLinksNew(self, smilesString):
        
        reso = self.numbers.findall(smilesString)
        if reso:
            count = 0
            maxCount = len(reso)-1
            renumCount = 0
            newReso = {}
            notStop = 1
            while notStop:
                if count > maxCount:
                    notStop = None
                else:
                    if not newReso.has_key(count):
                        currentNum = reso[count][1]
                        secCount = 0
                        # find the fitting closing number
                        for i in reso[count+1:]:
                            if i[1] == currentNum:
                                secCount += 1
                                newReso[count] = ('{*%s*' %renumCount,reso[count][0])
                                newReso[count+secCount] = (reso[count+secCount][0],'}*%s*' %renumCount)
                                currentNum = 'occupied'
                                renumCount += 1
                count += 1
            

            lastMatch = 0
            newString = smilesString
            for i in range(len(reso)):
                currentNumber = string.join(reso[i],'')
                newNumber = string.join(newReso[i],'')
                currentStart = smilesString.find(currentNumber)
                currentEnd = currentStart+len(currentNumber)
                #print currentNumber, newNumber, currentStart, currentEnd
                smilesString = smilesString[:currentStart]+newNumber+smilesString[currentEnd:]

            return smilesString
          
        else:
            return smilesString

    def renumberLinks(self, smilesString):

        lookup = {}
        currentMatches = []
        currentNum = 0
        workString = self.markOtherElementsCharge(smilesString)
        #workString = smilesString
        #print workString
        res = self.numbers.finditer(workString)

        last = 0
        retString = '' #  initialise

        try:
            match = res.next()
            last = match.start()
        except StopIteration:
            match = None
            pass

        retString = workString[:last] 
       
        while(match):            
            (matchNumberTemp)  = match.groups()[1]
            matchNumberList = self.plainNum.findall(matchNumberTemp)
            
            #print matchNumberList, matchNumberTemp,match.groups()
            matchString = match.group()
            matchStart  = match.start()
            matchEnd    = match.end()
            groups = match.groups()[0]

            retString = retString + workString[last:matchStart] 

            newNumString = ''
            wasStart = 0
            for num in matchNumberList:
                if num in currentMatches:
                    currentMatches.remove(num)
                    newNum = lookup[num]
                    newNumString = newNumString + '}*%s*' % newNum
                    lookup[num] = 'not used'
                else: #is a start
                    wasStart = 1
                    newNum = currentNum
                    currentNum += 1
                    lookup[num] = newNum
                    currentMatches.append(num)
                    newNumString = newNumString + '{*%s*' % newNum

            if wasStart:
                retString = retString + newNumString + groups
            else:
                retString = retString +  groups + newNumString
           
            last = matchEnd
 
            try:
                match = res.next()
            except StopIteration:
                match = None
                pass
        if last != 0:
            retString = retString + workString[last:]
        else:
            retString = smilesString

        # deb print retString
        retString = retString.replace('**','')
        retString = self.isolateElements(retString)
        return retString


    def removeUnbalancedMode(self,convertedSmilesString, mode):
        rH = reHelper()
        workString = convertedSmilesString
        if mode == 'right': # means i I was refineing to the right, only cases of missing closing barckets
            while(rH.isUnbalanced(workString)):
                #print workString
                (open,close) = rH.getNumBrackets(workString)
                #print (open-close)
                if open > close:
                    workString = workString+')'
                else:
                    #print workString
                    workString = rH.removeLeading(workString)
            #print workString
            return workString
        return workString
            


    def _getBracketFragments(self,convertedSmilesString ):
        rH = reHelper()
        return rH.splitBrackets1(convertedSmilesString)
       
    def _getNumberedFragments(self, convertedSmilesString):
        rH = reHelper()
        returnFragments = []
        workString = convertedSmilesString
        minNumLink = None
        maxNumLink = None

        numAllsString = self.uniqNums.findall(workString)
        numAlls = map(lambda x: string.atoi(x), numAllsString) # convert to interger list
        numAlls.sort()

        allNumsLen = rH.getDoubles(numAlls)
        for number in allNumsLen:
            try:
                extra = 0
                searchString = '(?:\{\*\d+\*)*(?:\{|\})\*%s\*(?:\}\*\d+\*)*' % number # we have to include numbers from before as they ultimatly belong to that element!!
                numSearch = re.compile(searchString)
                ind1 = numSearch.search(workString)
                
                #print '%s\t' % 1, len(workString),ind1.start()+1,workString
                ind2 = numSearch.search(workString, ind1.start()+len(ind1.group()))
                #print '%s\t' % 2,ind2.end(), len(workString), workString[ind2.end()-1+extra]
                if ind2.end()+extra < len(workString):
                    #print '%s\t' % 3,ind2.end()+extra
                    while((ind2.end()+extra < len(workString)) and (workString[ind2.end()+extra] is ')')):
                        extra += 1
                        #print "extra = %s" % extra
                returnFragments.append((workString[ind1.start():(ind2.end()+extra)], ind1.start(), ind2.end()+extra))
            except Exception, e:
                print workString
                print "error e(%s)= %s\n" % (convertedSmilesString,e)
                pass
        return returnFragments


    def analyse_with_numbers(self, convertedSmilesString, rootNode=None):

        #print convertedSmilesString
        if not rootNode or type(rootNode) is not type(Node('',None, 0, 1)):
            rootNode = Node(convertedSmilesString)
        
        returnFragList = []
        workString = convertedSmilesString

        mainFragments =  self.analyse_with_brackets(workString, rootNode)
        #print "Main fragments of %s:\n%s " % (convertedSmilesString, mainFragments)
        #print "Main fragments of %s:\n%s " % (convertedSmilesString, rootNode)
        returnFragList = returnFragList + mainFragments
        
        numberFragments = self._getNumberedFragments(convertedSmilesString)
        count = 0;
        for (fragment,s,e) in numberFragments:
            #print fragment
            fragment =  self.removeUnbalancedMode(fragment,'right')
            #print fragment
            fragment = self.correctBrackets(fragment)
            #print fragment
            #print self.convertBackToSmiles(fragment)
            
            count += 1
            numNode = Node(fragment, rootNode, s, e)
            rootNode.addChild(numNode, '%s' % count)
            returnFragList.append(fragment)
            bracketFrags = self.analyse_with_brackets(fragment, numNode)
            returnFragList = returnFragList + bracketFrags


        return returnFragList

    def correctBrackets(self,st):
        res = self.inBrackets.search(st)
        if res:
            #print st, res.start(), res.end(), res.group(1), len(st)
            if res.end() == len(st):
                st = st.replace('('+res.group(1)+')', res.group(1))
                st = st.replace('$','(')
                st = st.replace('/',')')
                if st[len(st)-1] == ')':
                    st = self.correctBrackets(st)
            else:
                st = st[:res.start()]+'$'+res.group(1)+'/'+st[res.end():]
                st = self.correctBrackets(st)
        else:
            st = st.replace('$','(')
            st = st.replace('/',')')
            

        return st

    def analyse_with_brackets(self, convertedSmilesString, parentNode=None):
        if not parentNode:
            parentNode  = Node(convertedSmilesString)
           
        workString = convertedSmilesString
        fragList = self._getBracketFragments(workString)

        returnFragList = []
        tempFragList   = []

        if fragList and type(fragList) is not type(''):
            tempFragList = []
            (a,b,c) = fragList

            aNode = Node(a, parentNode, 0, len(a))
            if a!= '':
                parentNode.addChild(aNode,'a')
                returnFragList.append(a) # allways has an 'a' part "abc"

            bNode = Node(b,parentNode, len(a), len(a)+1+len(b))
            if b != '': #case of "a(bc)"
                parentNode.addChild(bNode,'b')
                returnFragList.append(b)
                # add resulting fragments
                bFragList = self.analyse_with_numbers(b, bNode)
                #bFragList = self.analyse_with_brackets(b, bNode)
                returnFragList = returnFragList + bFragList

            cNode = Node(c,parentNode, len(a+b), len(a+b+c))
            if c != '': # case of "a(b)c"
                #print "cNode = %s" % cNode
                parentNode.addChild(cNode,'c')
                returnFragList.append(c)
                # add resulting fragments
                cFragList = self.analyse_with_numbers(c, cNode)
                #cFragList = self.analyse_with_brackets(c, cNode)
                returnFragList = returnFragList + cFragList
                

        elif type(fragList) is type(''): # is it a single string?
            if fragList != workString: # has changed -> there was something to put into fragments
                returnFragList.append(fragList)

 
        return returnFragList
            


 
        
    def compile(self, smilesString):
        if smilesString:
            convertedString = self.renumberLinks(smilesString)
            root = Node(convertedString,None, 0, len(convertedString))
            aList = self.analyse_with_numbers(convertedString, root)
            return root


    def setMatcher(self, matcher = None):
        if matcher:
            self.matcher = matcher
    def getMatcher(self):
        return self.matcher

    def matcherLoaded(self):
        if self.matcher:
            return 1
        else:
            return 0

    def printInfo(self, aString, number):
        if number and number<self.getVerbosityLevel()+1:
            out = self.getOutputFile()
            if out:
                print aString
                out.write(aString+'\n')
            else:
                print aString

    def printPerformance(self, acsii='.', finish=0):
        if finish:
            sys.stdout.writeline('\n')
            sys.stdout.flush()
        else:
             sys.stdout.write(ascii)
           

    def printSection(self, title='#####', rules=None, level=1):
        self.printHeader('***',level)
        self.printHeader(title,level)
        self.printHeader('***',level)
        if rules:
            self.printRulesNewType(rules,level)
        

    def printHeader(self, aString, number):
        la = len(aString)
        if la:
            numDashs = (120 - la - 2)/2
            if numDashs >= 0:
                self.printInfo('%s %s %s' % ('-'*numDashs,aString,'-'*numDashs), number)
            else:
                self.printInfo(' %s ' % (aString), number)



    def minPosSet(self):
        if self.minPos is not None:
            return 1
        else:
            return 0
    def getMinPos(self):
        return self.minPos
    def setMinPos(self, minPos):
        if minPos is not None:
            self.minPos = minPos

    def binSizeSet(self):
        if self.binSize is not None:
            return 1
        else:
            return 0
    def getBinSize(self):
        return self.binSize
    def setBinSize(self, binSize):
        if binSize is not None:
            self.binSize = binSize

    def maxNegSet(self):
        if self.maxNeg is not None:
            return 1
        else:
            return 0
    def getMaxNeg(self):
        return self.maxNeg
    def setMaxNeg(self, maxNeg):
        if maxNeg is not None:
            self.maxNeg = maxNeg

    def setVerbosityLevel(self,level):
        self.verbosityLevel = level
    def getVerbosityLevel(self):
        return self.verbosityLevel

    def setRuleDirectory(self, ruleDirectory):
        if ruleDirectory:
            self.ruleDirectory = os.path.normpath(ruleDirectory)
            if not os.path.exists(self.ruleDirectory):
                os.mkdir(self.ruleDirectory)

    def getRuleDirectory(self):
        return self.ruleDirectory

    def saveRules(self):
        if self.ruleDirectory:
            return 1
        return 0

    def getRuleFileName(self,suffix='rls',appendix=''):
        rulePath = self.getRuleDirectory()
        ruleFileName = 'rules%s.%s' % (appendix, suffix)
        return os.path.join(rulePath,ruleFileName)
    
    def writeRules(self, ruleFilename, rules, format):
        if ruleFilename and rules:
            ruleF = open(ruleFilename, 'w')
            rulesString = self.getRulesAsString(rules, format)
            ruleF.writelines(rulesString)
            ruleF.close()

    def writeRuleSets(self,appendRule, k, rules=None):
        if self.saveRules():
            appendRu = '%s%s' % (appendRule, string.zfill("%s" % (k), 2))
            rulesF = self.getRuleFileName(appendix=appendRu)
            self.writeRules(rulesF, rules,'readable')
            rulesF = self.getRuleFileName(suffix='pl',appendix=appendRu)
            self.writeRules(rulesF, rules,'prolog')
            rulesF = self.getRuleFileName(suffix='csv',appendix=appendRu)
            self.writeRules(rulesF, rules,'csv')

    def writeExamplesNames(self,ruleFilename,positives,negatives):
        positives.sort()
        negatives.sort()
        (namesA,namesI,intIDA,intIDI) = (None,None,None,None)
        if self.relationSet():
            rel = self.getRelation()
            namesA = map(lambda x: rel.getAttribute(x,'active'),positives)
            intIDA = rel.convertToInternalID('active',positives)
            namesI = map(lambda x: rel.getAttribute(x,'inactive'),negatives)
            intIDI = rel.convertToInternalID('inactive',negatives)
        activesS = 'actives = [%s,%s,%s]\n' % (positives,intIDA,namesA)
        inactivesS = 'inactives = [%s,%s,%s]\n' % (negatives,intIDI,namesI)
        fileHandle = open(ruleFilename,'w')
        fileHandle.writelines(['# name = [[SMIPPER-ID],[Number in ARFF],[Names (cas or id)]]\n\n',activesS,inactivesS])
        fileHandle.close()

        
    def setRocFile(self, rocFileName):
        if rocFileName:
            direc = os.path.dirname(rocFileName)
            if not os.path.exists(direc):
                os.mkdir(direc)
            self.rocFileName = rocFileName
    def getRocFileName(self,suffix='roc',appendix=''):
        returnFileName = self.rocFileName + appendix
        if suffix is not None:
            return  returnFileName + '.' + suffix
        else:
            return returnFileName
    def produceRocFiles(self):
        return self.rocFileName
    
    def foil_gain(self, posNewL, negNewL, posOldL, negOldL):
        #print "foil_gain"
        li = Lists()

        posNew = len(posNewL)
        negNew = len(negNewL)
        posOld = len(posOldL)
        negOld = len(negOldL)

        divNew = (posNew+negNew)*1.0
        if divNew == 0 or posNew == 0 or posOld == 0:
            return -1000
        divOld = (posOld+negOld)*1.0

        tL = li.intersection(posNewL,posOldL)
        t = len(tL)

        log2 = math.log(2)

        #print posNew,divNew, posNew/divNew
        term1 = math.log(posNew/divNew)/log2
        #print posOld,divOld, posOld/divOld
        term2 = math.log(posOld/divOld)/log2

        return t*(term1-term2)
         
     
    def i_gain(self, pos, neg, Pos, Neg):
        #print pos, neg, Pos, Neg
        if pos == neg == 0:
            return 0
        ES = self.entropy(Pos, Neg)
        ER1 = self.entropy(pos,neg)
        ER2 = self.entropy((Pos-pos),(Neg-neg))
        rER1 = (pos+neg)*1.0/(Pos+Neg) * ER1
        rER2 = ((Pos-pos)+(Neg-neg))*1.0/(Pos+Neg) * ER2
        return ES -rER1 -rER2

    def entropy(self, pos, neg):
        sum = pos + neg
        if pos == 0 or neg == 0:
            return 0.0
        log2 = math.log(2)
        f1 = ((-1.0 * pos)/sum)*(math.log(1.0*pos/sum)/log2)
        f2 = ((-1.0 * neg)/sum)*(math.log(1.0*neg/sum)/log2)
        return f1 + f2


    def mdl(self, n, k, p):
        log2 = math.log(2)
        if p is not 0 and (1-p) is not 0:
            return k*1.0*math.log(1.0/p)/log2 + (n-k)*1.0*math.log(1.0/(1.0-p))/log2
        else:
            print 'FAIL'

    def registerHeuristics(self):
        lookFor = 'heuristic_'
        methods = dir(self)
        for method in methods:
            if method.startswith(lookFor):
                methodName = method[len(lookFor):]
                methodAddr = getattr(self,method)
                if callable(methodAddr):
                    self.heuristics[methodName] = methodAddr
        for me in self.heuristics.keys():
            self.printInfo("registered %s as heuristic" % me ,2)
        return

    def hasHeuristic(self,heuristicName):
        if heuristicName in self.heuristics.keys():
            return 1
        return 0

    def getAvailableHeuristics(self):
        return self.heuristics.keys()

    def selectHeuristic(self,heuristicName):
        if self.hasHeuristic(heuristicName):
            self.useHeuristicName = heuristicName
            self.useHeuristicFunction = self.heuristics[heuristicName]
            self.printInfo("selected %s as pruning heuristic" % heuristicName,2)

    def isHeuristicsSet(self):
        return self.useHeuristicFunction

    def calculateHeuristic(self,pos=0, neg=0, Pos = 0, Neg = 0):
        #print "calculateHeuristic"
        if self.isHeuristicsSet:
            return self.useHeuristicFunction(pos,neg,Pos,Neg)

    def heuristic_compute_v(self, pos=0, neg=0, Pos = 0, Neg = 0):

        if self.maxNegSet():
            if neg > self.getMaxNeg():
                return -1.0

        # ak to be removed again
        if self.minPosSet():
            if pos < self.getMinPos():
                return -1.0+(0.1*self.getMinPos())

        if pos == 0:
            return -1.0-(1.0*neg)

        if pos == neg == 0:
            return -1.0

        
        pos += 1
        neg += 1

        div = pos+neg
        return ((pos - neg)*1.0/div)

    def heuristic_wracc(self,pos=0, neg=0, Pos = 0, Neg = 0):

        nB  = pos+neg
        if nB <= 0.0:
            return 0.0
        nH  = Pos
        nHB = pos


        pB  = 1.0*nB/(Pos+Neg)
        pH  = 1.0*nH/(Pos+Neg)
        pHB = 1.0*nHB/(Pos+Neg)


        wracc = pB*((pHB/pB)-pH)

        return wracc
        
    ################
    # file section
    ################

    # an alternative to smiles files. should be in specialised ARFF format. uses DataFormater()
    def incorporateInputFile(self, inputFileName=None , mode="training"):
        if inputFileName:
            print "\n\nLOAD %s\n\n" % inputFileName
            # hack!!!!!
            if mode=="test":
                relNo = 1
            else:
                relNo = 0
            print "relNum = %s" % relNo

            # if no other bin size is set (-z option), then all numerical attributes are used (=0)
            binSize = 0
            if self.binSizeSet():
                binSize = self.getBinSize()
            DF = DataFormater(inputFileName,binSize)
            # ak testing JCC paper
            #print DF.relations[0].bins, len(DF.relations[0].bins['mw'])
            
            
            activeDB = DF.writeCompoundsInTempSmilesFile(condition='class=active', relNum=relNo)
            inactiveDB = DF.writeCompoundsInTempSmilesFile(condition='class=inactive', relNum=relNo)
            return (DF,activeDB,inactiveDB)

    def cleanupInputFiles(self,fileNames = []):
        for fileName in fileNames:
            os.remove(fileName)

    def setRelationMode(self,mode='training'):
        if mode == 'training' or mode == 'test':
            self.relationMode = mode

    def getRelationMode(self):
        return self.relationMode

    def getRelNum(self):
        if self.getRelationMode() == 'training':
            return 0
        elif self.getRelationMode() == 'test':
            return 1
        else:
            return -1
        

    def setRelation(self, relation, mode='training'):
        if relation:
            if mode=='training':
                self.relation = relation
                self.relationLoaded = 1
            elif mode=='test':
                self.relationT = relation
                self.relationLoaded = 1
            else:
                raise "Unknown mode in setRelation\n"

    def getRelation(self, mode=None):
        if mode=='training':
            return self.relation
        elif mode=='test':
            return self.relationT
        else:
            return self.getRelation(self.getRelationMode())
            #raise "Unknown mode in getRelation\n"
    
    def relationSet(self):
        return self.relationLoaded
    

    ###########################
    # splitting of example sets
    ###########################
        
    def splitExampleSets(self, posSet, negSet, splitPercentage=0.3333):
        (posG, posP) = self.splitExampleSet(posSet, splitPercentage)
        (negG, negP) = self.splitExampleSet(negSet, splitPercentage)
        return (posG, negG, posP, negP)
    
    def splitExampleSet(self, posSet, splitPercentage=0.3333):
        li = Lists()

        posSetTemp = li.copy(posSet)

        posS = len(posSet)
        posG = []

        while len(posSet) > 0 and len(posG) <= int(posS*splitPercentage):
            #random.seed(20)
            randy = random.randrange(len(posSetTemp))
            posG.append(posSetTemp[randy])
            posSetTemp.remove(posSetTemp[randy])

        posP = li.subtract(posSet, posG)
        
        return (posG, posP)

    ###########################
    # top level IREPs
    ##########################

    def IREP_TestSet(self, dbFileNameA, dbFileNameI, dbFileNameAT, dbFileNameIT, minPos=None, maxNeg=None, maxErrorRate=50.0, splitPercentage=0.66666,  beamSize = 10, numSeeds=10):

        # setting the datbases to None, in order to load them later on
        db  = None
        dbT = None
        if dbFileNameI == 'arff':
            # loads in the data from arff file, writes data in temporary smiles files
            (db, dbFileNameA, dbFileNameI) = self.incorporateInputFile(dbFileNameA)
            self.setRelation(db.getRelation())
            # here I expect the test file to be in ARFF format as well
            if dbFileNameIT == 'arff':
                (dbT, dbFileNameAT, dbFileNameIT) = self.incorporateInputFile(dbFileNameAT,mode="test")
                self.setRelation(dbT.getRelation(),'test')
           
            #self.setRelationMode('training')
            #print db.getCompoundsAsSmiles(relNum=self.getRelNum())
            #print
            #self.setRelationMode('test')
            #print dbT.getCompoundsAsSmiles(relNum=self.getRelNum())

        if minPos is not None:
            self.setMinPos(minPos)
        if maxNeg is not None:
            self.setMaxNeg(maxNeg)

        li = Lists()

        matcher = self.getMatcher() 
        dbNumA  = matcher.loadDB(dbFileNameA)
        dbNumI  = matcher.loadDB(dbFileNameI)
        dbNumAT  = matcher.loadDB(dbFileNameAT)
        dbNumIT  = matcher.loadDB(dbFileNameIT)

        allPos = matcher.getCurrentMatchSet(dbNumA)
        allNeg = matcher.getCurrentMatchSet(dbNumI)
        allPosT = matcher.getCurrentMatchSet(dbNumAT)
        allNegT = matcher.getCurrentMatchSet(dbNumIT)

        if not maxErrorRate:
            maxErrorRate = 100.0*len(allNeg)/(len(allPos)+len(allNeg))

        allRules = []

        self.printHeader('***',1)
        self.printHeader("SMIREP",1)
        self.printHeader('maxErrorRate = %5.4f' % (maxErrorRate),1)
        self.printHeader('***',1)

        # set relation mode to training, nec. for evaluation:
        self.setRelationMode('training')

        rulesThisRound = self.IREP(dbNumA, dbNumI, maxErrorRate, splitPercentage, numSeeds,beamSize=beamSize, dataFormatter=db)

        self.printSection('Rules on Training', rules = rulesThisRound, level=1)


        # new roc test
        rocTrain = self.calculateROCCurve2(rulesThisRound,len(allPos),len(allNeg))

        # def produce ROCcurve
        if self.produceRocFiles():                
            appendix = "_train" 
            rocFileName = self.getRocFileName(appendix=appendix)
            self.writeRocData(rocFileName, rocTrain)

        # save rule if required
        self.writeRuleSets('_train', 0, rulesThisRound)

        tp = 0
        fp = 0
        for rule in rulesThisRound :
            tpL = len(rule['matchingA'])
            fpL = len(rule['matchingI'])
            tp  += tpL
            fp  += fpL

        fn = len(allPos)-tp
        tn = len(allNeg)-fp
        self.printInfo('TP = %s' % (tp),3)
        self.printInfo('FP = %s' % (fp),3)
        self.printInfo('FN = %s' % (fn),3)
        self.printInfo('TN = %s' % (tn),3)
        AUCTr = 0.0
        if tp>0:
            self.printInfo('Precision    = %s' % (tp*1.0/(tp+fp)),5)
            self.printInfo('Recall       = %s' % (tp*1.0/(tp+fn)),5)
            AUCTr = self.getAUC(rocTrain)
            self.printInfo('AreaUnderROC = %s' % (AUCTr),5)
       
        results = [[tp,fp,tn,fn]]

        matcher.setCurrentMatchSet(dbNumAT, allPosT)
        matcher.setCurrentMatchSet(dbNumIT, allNegT)

        tp = 0
        fp = 0
            
        #rescoredRules = self.rescoreRuleOnFullSet(dbNumAT, dbNumIT, rulesThisRound)

        actualMinPos = -1
        if self.minPosSet:
            actualMinPos = self.getMinPos()
            self.setMinPos(0)


        # set relation mode to test, nec. for evaluation:
        self.setRelationMode('test')

        

        rescoredRules = []
        for rule in rulesThisRound :
            [rescoredRule] = self.rescoreRuleOnFullSet(dbNumAT, dbNumIT, [rule])
            rescoredRules.append(rescoredRule)
            tpL = len(rescoredRule['matchingA'])
            fpL = len(rescoredRule['matchingI'])
            self.retractSamplesCovered(dbNumAT, dbNumIT, rescoredRules)
            tp  += tpL
            fp  += fpL


        # restore min pos if it was set
        if self.minPosSet:
            self.setMinPos(actualMinPos)

        self.printSection('Rules on Testing', rules = rescoredRules, level=1)

        rocTest = self.calculateROCCurve2(rescoredRules,len(allPosT),len(allNegT))
        #rocCurvesTest.append(rocTest)

        # def produce ROCcurve
        if self.produceRocFiles():                
            appendix = "_test" 
            rocFileName = self.getRocFileName(appendix=appendix)
            self.writeRocData(rocFileName, rocTest)

        # save rule if required
        if self.saveRules():
            appendRu = '_test' 
            rulesF = self.getRuleFileName(appendix=appendRu)
            self.writeRules(rulesF, rescoredRules,'readable')
            rulesF = self.getRuleFileName(suffix='pl',appendix=appendRu)
            self.writeRules(rulesF, rescoredRules,'prolog')
            rulesF = self.getRuleFileName(suffix='csv',appendix=appendRu)
            self.writeRules(rulesF, rescoredRules,'csv')

        fn = len(allPosT)-tp
        tn = len(allNegT)-fp

        accuracy = 100*(tp+tn)/(1.0*(tp+tn+fp+fn))
            
        self.printHeader('ACCURACY',1)
        self.printInfo('Accuracy = %s' % ( accuracy),5)
        self.printInfo('TP = %s' % (tp),3)
        self.printInfo('FP = %s' % (fp),3)
        self.printInfo('FN = %s' % (fn),3)
        self.printInfo('TN = %s' % (tn),3)
        AUCTe = 0.5
        if tp>0:
            self.printInfo('Precision = %s' % (tp*1.0/(tp+fp)),5)
            self.printInfo('Recall    = %s' % (tp*1.0/(tp+fn)),5)
            AUCTe = self.getAUC(rocTest)
            self.printInfo('AreaUnderROC = %s' % (AUCTe),5)

        results.append([tp,fp,tn,fn])
        results.append((AUCTr,AUCTe))
        resA = self.getPreRec(results)

        # set i to 'lt'
        i = 'tl'
        
        self.printInfo("\n i\tdAccTr\tAccTr\tPreTr\tRecTr\tdAccTe\tAccTe\tPreTe\tRecTe\tAUCTr\tAUCTe",1)
        self.printInfo( "%2s\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n" % ((i,)+resA), 1)

        
    def IREP_k_fold(self, dbFileNameA, dbFileNameI, minPos=None, maxNeg=None, maxErrorRate=50.0, splitPercentage=0.66666,  beamSize = 10, k=10, numSeeds=10):

        db = None
        if dbFileNameI == 'arff':
            # loads in the data from arff file, writes data in temporary smiles files
            (db, dbFileNameA, dbFileNameI) = self.incorporateInputFile(dbFileNameA)
            self.setRelation(db.getRelation(),'training')

        # set relation mode to training, nec. for evaluation:
        self.setRelationMode('training')

        #self.printInfo("k=%s" %k,5)
        
        if minPos is not None:
            self.setMinPos(minPos)
        if maxNeg is not None:
            self.setMaxNeg(maxNeg)


        li = Lists()

        timer = Timer()
        times = []

        matcher = self.getMatcher() 
        dbNumA  = matcher.loadDB(dbFileNameA)
        dbNumI  = matcher.loadDB(dbFileNameI)

        allPos = matcher.getCurrentMatchSet(dbNumA)
        allNeg = matcher.getCurrentMatchSet(dbNumI)

        print "s %s %s" % (len(allPos),len(allNeg))

        if not maxErrorRate:
            maxErrorRate = 100.0*len(allNeg)/(len(allPos)+len(allNeg))

        splittedPos = []
        splittedNeg = []
        
        splittedPos = li.splitIntoKRandom(allPos,k)
        splittedNeg = li.splitIntoKRandom(allNeg,k)


        allRules = []
        resultsList = []
        accuracies = []
        rocCurvesTest  = []
        rocCurvesTrain = []

        for i in range(k):
            timer.reset()
            timer.start()
            self.printSection('i = %s' % (i+1),None, 1)

            currentTestPos = splittedPos[i]
            currentTestNeg = splittedNeg[i]
            lenCurrentTestPos = len(currentTestPos)
            lenCurrentTestNeg = len(currentTestNeg)
            currentTrainPos = []
            currentTrainNeg = []
            rocTrain = None
            rocTest  = None

            for j in range(k):
                if j != i:
                    currentTrainPos = currentTrainPos + splittedPos[j]
                    currentTrainNeg = currentTrainNeg + splittedNeg[j]

            #debug:  to be removed, only for large datasets
            #if len(currentTrainNeg) > len(currentTrainPos)*10:
            #    currentTrainNeg = li.randList(currentTrainNeg,int(len(currentTrainNeg)/2))
                
            # record the splits (activated if rules are to be written)
            if self.saveRules():
                appendRu = 'Split_train_k%s' % (string.zfill("%s" % (i+1), 2))
                rulesF = self.getRuleFileName(appendix=appendRu,suffix='list')
                self.writeExamplesNames(rulesF,currentTrainPos,currentTrainNeg)
                appendRu = 'Split_test_k%s' % (string.zfill("%s" % (i+1), 2))
                rulesF = self.getRuleFileName(appendix=appendRu,suffix='list')
                self.writeExamplesNames(rulesF,currentTestPos,currentTestNeg)
                

            matcher.setCurrentMatchSet(dbNumA, currentTrainPos)
            matcher.setCurrentMatchSet(dbNumI, currentTrainNeg)

            rulesThisRound = self.IREP(dbNumA, dbNumI, maxErrorRate, splitPercentage, numSeeds,beamSize=beamSize,dataFormatter=db)

            self.printSection('Rules on Training', rules = rulesThisRound, level=1)

            # new roc test
            rocTrain = self.calculateROCCurve2(rulesThisRound,len(currentTrainPos),len(currentTrainNeg))
            rocCurvesTrain.append(rocTrain)

            # def produce ROCcurve
            if self.produceRocFiles():                
                #rocTrain = self.calculateROCCurve(rulesThisRound)
                appendix = "_train_k%s" % (string.zfill("%s" % (i+1), 2))
                rocFileName = self.getRocFileName(appendix=appendix)
                self.writeRocData(rocFileName, rocTrain)

            # save rule if required
            self.writeRuleSets('_train_k', (i+1), rulesThisRound)
                
            tp = 0
            fp = 0
            for rule in rulesThisRound :
                tpL = len(rule['matchingA'])
                fpL = len(rule['matchingI'])
                tp  += tpL
                fp  += fpL

            fn = len(currentTrainPos)-tp
            tn = len(currentTrainNeg)-fp
            results = [[tp,fp,tn,fn]]
            self.printInfo('TP = %s' % (tp),3)
            self.printInfo('FP = %s' % (fp),3)
            self.printInfo('FN = %s' % (fn),3)
            self.printInfo('TN = %s' % (tn),3)
            AUCTr = 0.0
            if tp>0:
                self.printInfo('Precision    = %s' % (tp*1.0/(tp+fp)),5)
                self.printInfo('Recall       = %s' % (tp*1.0/(tp+fn)),5)
                AUCTr = self.getAUC(rocTrain)
                self.printInfo('AreaUnderROC = %s' % (AUCTr),5)
       
            matcher.setCurrentMatchSet(dbNumA, currentTestPos)
            matcher.setCurrentMatchSet(dbNumI, currentTestNeg)

            tp = 0
            fp = 0
            
            #rescoredRules = self.rescoreRuleOnFullSet(dbNumA, dbNumI, rulesThisRound)

            # take out min pos if set
            actualMinPos = -1
            if self.minPosSet:
                actualMinPos = self.getMinPos()
                self.setMinPos(0)
                

            rescoredRules = []
            for rule in rulesThisRound :
                [rescoredRule] = self.rescoreRuleOnFullSet(dbNumA, dbNumI, [rule])
                rescoredRules.append(rescoredRule)
                tpL = len(rescoredRule['matchingA'])
                fpL = len(rescoredRule['matchingI'])
                self.retractSamplesCovered(dbNumA, dbNumI, rescoredRules)
                tp  += tpL
                fp  += fpL

            # restore min pos if it was set
            if self.minPosSet:
                self.setMinPos(actualMinPos)
                
            self.printSection('Rules on Testing', rules = rescoredRules, level=1)

            rocTest = self.calculateROCCurve2(rescoredRules,lenCurrentTestPos,lenCurrentTestNeg)
            rocCurvesTest.append(rocTest)

            # def produce ROCcurve
            if self.produceRocFiles():                
                #rocTest = self.calculateROCCurve(rescoredRules)
                appendix = "_test_k%s" % (string.zfill("%s" % (i+1), 2))
                rocFileName = self.getRocFileName(appendix=appendix)
                self.writeRocData(rocFileName, rocTest)

            # save rule if required
            if self.saveRules():
                appendRu = '_test_k%s' % (string.zfill("%s" % (i+1), 2))
                rulesF = self.getRuleFileName(appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'readable')
                rulesF = self.getRuleFileName(suffix='pl',appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'prolog')
                rulesF = self.getRuleFileName(suffix='csv',appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'csv')
                

            fn = lenCurrentTestPos-tp
            tn = lenCurrentTestNeg-fp

            accuracy = 100*(tp+tn)/(1.0*(tp+tn+fp+fn))

            self.printHeader('ACCURACY',1)
            self.printInfo('Accuracy (i=%s) = %s' % (i+1, accuracy),5)
            self.printInfo('TP = %s' % (tp),3)
            self.printInfo('FP = %s' % (fp),3)
            self.printInfo('FN = %s' % (fn),3)
            self.printInfo('TN = %s' % (tn),3)
            AUCTe = 0.5
            if tp>0:
                self.printInfo('Precision = %s' % (tp*1.0/(tp+fp)),5)
                self.printInfo('Recall    = %s' % (tp*1.0/(tp+fn)),5)
                AUCTe = self.getAUC(rocTest)
                self.printInfo('AreaUnderROC = %s' % (AUCTe),5)
                
            results.append([tp,fp,tn,fn])
            results.append((AUCTr,AUCTe))
            resA = self.getPreRec(results)
            self.printInfo("\n i\tdAccTr\tAccTr\tPreTr\tRecTr\tdAccTe\tAccTe\tPreTe\tRecTe\tAUCTr\tAUCTe",1)
            self.printInfo( "%2s\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n" % ((i,)+resA), 1)

            
            for rule in rescoredRules:
                self.retractSamplesCovered(dbNumA, dbNumI, [rule])

            accuracies.append(accuracy)
            resultsList.append(results)

            #free stuff
            #rapporter('Global before')
            #if self.has_key(globalFragsUsed):
            
            for rootFrag in self.globalFragsUsed+ self.globalFrags:
                rootFrag.__del__()
            del self.globalFragsUsed
            self.globalFragsUsed = []
            del rulesThisRound
            del rescoredRules
            
            timer.stop()
            duration = timer.getTimeSecs()
            times.append(duration)
            self.printHeader('Time',1)
            self.printInfo("Time (i = %2s) = %s s" % (i+1,(duration)),1)

        sumDefAccTr = 0.0
        sumAccTr    = 0.0
        sumPreTr    = 0.0
        sumRecTr    = 0.0
        sumDefAccTe = 0.0
        sumAccTe    = 0.0
        sumPreTe    = 0.0
        sumRecTe    = 0.0
        sumAUCTr    = 0.0
        sumAUCTe    = 0.0
        j = 0
        self.printInfo("\n\n\ni\tdAccTr\tAccTr\tPreTr\tRecTr\tdAccTe\tAccTe\tPreTe\tRecTe\tAUCTr\tAUCTe",1)
        for res in resultsList:
            j += 1
            resA = self.getPreRec(res)
            sumDefAccTr += resA[0]
            sumAccTr    += resA[1]
            sumPreTr    += resA[2]
            sumRecTr    += resA[3]
            sumDefAccTe += resA[4]
            sumAccTe    += resA[5]
            sumPreTe    += resA[6]
            sumRecTe    += resA[7]
            sumAUCTr    += resA[8]
            sumAUCTe    += resA[9]
            self.printInfo( "%2s\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % ((j,)+resA), 1)
            

        (averDefAccTr, averAccTr, averPreTr, averRecTr, averDefAccTe, averAccTe, averPreTe,averRecTe,averAUCTr,averAUCTe) = map(lambda x: x*1.0/len(resultsList), (sumDefAccTr,sumAccTr,sumPreTr,sumRecTr,sumDefAccTe,sumAccTe,sumPreTe,sumRecTe,sumAUCTr,sumAUCTe))
        self.printHeader("averages",1)
        self.printInfo("av\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (averDefAccTr, averAccTr, averPreTr, averRecTr, averDefAccTe, averAccTe, averPreTe,averRecTe,averAUCTr,averAUCTe),1)

        i=1
        sumAcc = 0.0
        self.printHeader('Accuracies',1)
        for acc in accuracies:
            sumAcc += acc
            self.printInfo("Acc (i = %s) = %5.2f" % (i,acc),1)
            i += 1
        self.printInfo("AvrgAcc = %5.2f)"% (sumAcc*1.0/k), 1)

        i=1
        self.printHeader('Times',6)
        for t in times:
            self.printInfo("Time (i =%2s) = %10s s" % (i,t),6)
            i += 1

        if self.produceRocFiles():
            #rocAvgTrain = self.averageRocCurves(rocCurvesTrain)
            rocAvgTrain = self.mergeRocCurves(rocCurvesTrain)
            appendixTrain  = "_train_average" 
            rocFileNameTrain  = self.getRocFileName(appendix=appendixTrain)
            self.writeRocData(rocFileNameTrain, rocAvgTrain)
            self.writeRocGnuplotCommands('train',k)
            
            #rocAvgTest = self.averageRocCurves(rocCurvesTest)
            rocAvgTest = self.mergeRocCurves(rocCurvesTest)
            appendixTest  = "_test_average" 
            rocFileNameTest  = self.getRocFileName(appendix=appendixTest)
            self.writeRocData(rocFileNameTest, rocAvgTest)
            self.writeRocGnuplotCommands('test',k)

        if dbFileNameI == 'arff':
            # removes temporary smiles files
            self.cleanupInputFiles([dbFileNameA, dbFileNameI])

    def IREP_leaveOneOut(self, dbFileNameA, dbFileNameI, minPos=None, maxNeg=None, maxErrorRate=50.0, splitPercentage=0.66666,  beamSize = 10,  numSeeds=10):
        db = None
        if dbFileNameI == 'arff':
            # loads in the data from arff file, writes data in temporary smiles files
            (db, dbFileNameA, dbFileNameI) = self.incorporateInputFile(dbFileNameA)
            self.setRelation(db.getRelation())

        # set relation mode to training, nec. for evaluation:
        self.setRelationMode('training')
        
        if minPos is not None:
            self.setMinPos(minPos)
        if maxNeg is not None:
            self.setMaxNeg(maxNeg)


        li = Lists()

        timer = Timer()
        times = []

        matcher = self.getMatcher() 
        dbNumA  = matcher.loadDB(dbFileNameA)
        dbNumI  = matcher.loadDB(dbFileNameI)

        allPos = matcher.getCurrentMatchSet(dbNumA)
        allNeg = matcher.getCurrentMatchSet(dbNumI)

        if not maxErrorRate:
            maxErrorRate = 100.0*len(allNeg)/(len(allPos)+len(allNeg))

        currentTrainNegL = []
        currentTrainPosL = []
        currentTestNegL = []
        currentTestPosL = []

        numPos = len(allPos)
        numNeg = len(allNeg)
        allCount = numPos + numNeg
            
        for i in range(numPos):
            dummy1 = filter(lambda x: x is not i+1,allPos)
            #self.printInfo("%s dummy1 %s" % (i,dummy1),5)
            dummy2 = li.copy(allNeg)
            #random.seed(20)
            random.shuffle(dummy1)
            random.shuffle(dummy2)
            currentTrainPosL.append(dummy1)
            currentTrainNegL.append(dummy2)
            currentTestPosL.append([i+1])
            currentTestNegL.append([])
        for i in range(numNeg):
            dummy1 = filter(lambda x: x is not i,allNeg)
            #self.printInfo("dummy1 %s" % dummy1,5)
            dummy2 = li.copy(allPos)
            #random.seed(20)
            random.shuffle(dummy1)
            random.shuffle(dummy2)
            currentTrainNegL.append(dummy1)
            currentTrainPosL.append(dummy2)
            currentTestPosL.append([])
            currentTestNegL.append([i+1])

        self.printInfo("allCount=%s" %allCount,5)
        
        allRules = []
        resultsList = []
        accuracies = []
        rocCurvesTest  = []
        rocCurvesTrain = []


        for i in range(allCount):
            timer.reset()
            timer.start()
            self.printHeader('***',1)
            self.printHeader('i = %s' % (i+1),1)
            self.printHeader('maxErrorRate = %5.4f' % (maxErrorRate),1)
            self.printHeader('***',1)
            currentTrainPos = currentTrainPosL[i]
            currentTrainNeg = currentTrainNegL[i]
            currentTestPos = currentTestPosL[i]
            currentTestNeg = currentTestNegL[i]
            lenCurrentTestPos = len(currentTestPos)
            lenCurrentTestNeg = len(currentTestNeg)


            rocTrain = None
            rocTest  = None


            matcher.setCurrentMatchSet(dbNumA, currentTrainPos)
            matcher.setCurrentMatchSet(dbNumI, currentTrainNeg)

            rulesThisRound = self.IREP(dbNumA, dbNumI, maxErrorRate, splitPercentage, numSeeds,beamSize=beamSize,dataFormatter=db)
            if rulesThisRound:
                rulesThisRound.sort(sortRules)
            self.printHeader('***',1)
            self.printHeader('i = %s' % (i+1),1)
            self.printHeader('Rules on Training',1)
            self.printHeader('***',1)
            self.printRulesNewType(rulesThisRound,1)
            # def produce ROCcurve
            if self.produceRocFiles():                
                rocTrain = self.calculateROCCurve(rulesThisRound)
                appendix = "_train_k%s" % (string.zfill("%s" % (i+1), 2))
                rocFileName = self.getRocFileName(appendix=appendix)
                self.writeRocData(rocFileName, rocTrain)
                rocCurvesTrain.append(rocTrain)

            # save rule if required
            if self.saveRules():
                appendRu = '_train_k%s' % (string.zfill("%s" % (i+1), 2))
                rulesF = self.getRuleFileName(appendix=appendRu)
                self.writeRules(rulesF, rulesThisRound,'readable')
                rulesF = self.getRuleFileName(suffix='pl',appendix=appendRu)
                self.writeRules(rulesF, rulesThisRound,'prolog')
                rulesF = self.getRuleFileName(suffix='csv',appendix=appendRu)
                self.writeRules(rulesF, rulesThisRound,'csv')
                
            tp = 0
            fp = 0

            if rulesThisRound:
            
                for rule in rulesThisRound :
                    tpL = len(rule['matchingA'])
                    fpL = len(rule['matchingI'])
                    tp  += tpL
                    fp  += fpL

            fn = len(allPos)-tp
            tn = len(allNeg)-fp
            results = [[tp,fp,tn,fn]]
            self.printInfo('TP = %s' % (tp),3)
            self.printInfo('FP = %s' % (fp),3)
            self.printInfo('FN = %s' % (fn),3)
            self.printInfo('TN = %s' % (tn),3)
            if tp>0:
                self.printInfo('Precision = %s' % (tp*1.0/(tp+fp)),5)
                self.printInfo('Recall    = %s' % (tp*1.0/(tp+fn)),5)
       
            matcher.setCurrentMatchSet(dbNumA, currentTestPos)
            matcher.setCurrentMatchSet(dbNumI, currentTestNeg)

            tp = 0
            fp = 0
            
            rescoredRules = []
            if rulesThisRound:
                for rule in rulesThisRound :
                    [rescoredRule] = self.rescoreRuleOnFullSet(dbNumA, dbNumI, [rule])
                    rescoredRules.append(rescoredRule)
                    tpL = len(rescoredRule['matchingA'])
                    fpL = len(rescoredRule['matchingI'])
                    self.retractSamplesCovered(dbNumA, dbNumI, rescoredRules)
                    tp  += tpL
                    fp  += fpL

            self.printHeader('***',1)
            self.printHeader('Rules on Testing',1)
            self.printHeader('***',1)
            self.printRulesNewType(rescoredRules,1)

            # def produce ROCcurve
            if self.produceRocFiles():                
                rocTest = self.calculateROCCurve(rescoredRules)
                appendix = "_test_k%s" % (string.zfill("%s" % (i+1), 2))
                rocFileName = self.getRocFileName(appendix=appendix)
                self.writeRocData(rocFileName, rocTest)
                rocCurvesTest.append(rocTest)

            # save rule if required
            if self.saveRules():
                appendRu = '_test_k%s' % (string.zfill("%s" % (i+1), 2))
                rulesF = self.getRuleFileName(appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'readable')
                rulesF = self.getRuleFileName(suffix='pl',appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'prolog')
                rulesF = self.getRuleFileName(suffix='csv',appendix=appendRu)
                self.writeRules(rulesF, rescoredRules,'csv')
                
            # def produce ROCcurve
            if self.produceRocFiles():
                rocTest = self.calculateROCCurve(rescoredRules)
            # def produce ROCcurve

            fn = lenCurrentTestPos-tp
            tn = lenCurrentTestNeg-fp

            accuracy = 100*(tp+tn)/(1.0*(tp+tn+fp+fn))

            self.printHeader('ACCURACY',1)
            self.printInfo('Accuracy (i=%s) = %s' % (i+1, accuracy),5)
            self.printInfo('TP = %s' % (tp),3)
            self.printInfo('FP = %s' % (fp),3)
            self.printInfo('FN = %s' % (fn),3)
            self.printInfo('TN = %s' % (tn),3)
            if tp>0:
                self.printInfo('Precision = %s' % (tp*1.0/(tp+fp)),5)
                self.printInfo('Recall    = %s' % (tp*1.0/(tp+fn)),5)
                
            results.append([tp,fp,tn,fn])
            resA = self.getPreRec(results)
            self.printInfo("\n i\tdAccTr\tAccTr\tPreTr\tRecTr\tdAccTe\tAccTe\tPreTe\tRecTe",1)
            self.printInfo( "%2s\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n" % ((i,)+resA), 1)

            
            for rule in rescoredRules:
                self.retractSamplesCovered(dbNumA, dbNumI, [rule])

            accuracies.append(accuracy)
            resultsList.append(results)
            timer.stop()
            duration = timer.getTimeSecs()
            times.append(duration)
            self.printHeader('Time',1)
            self.printInfo("Time (i = %2s) = %s s" % (i+1,(duration)),1)

        sumDefAccTr = 0.0
        sumAccTr    = 0.0
        sumPreTr    = 0.0
        sumRecTr    = 0.0
        sumDefAccTe = 0.0
        sumAccTe    = 0.0
        sumPreTe    = 0.0
        sumRecTe    = 0.0
        j = 0
        self.printInfo("\n\n\ni\tdAccTr\tAccTr\tPreTr\tRecTr\tdAccTe\tAccTe\tPreTe\tRecTe",1)
        for res in resultsList:
            j += 1
            resA = self.getPreRec(res)
            sumDefAccTr += resA[0]
            sumAccTr    += resA[1]
            sumPreTr    += resA[2]
            sumRecTr    += resA[3]
            sumDefAccTe += resA[4]
            sumAccTe    += resA[5]
            sumPreTe    += resA[6]
            sumRecTe    += resA[7]
            sumAUCTr    += resA[8]
            sumAUCTe    += resA[9]
            self.printInfo( "%2s\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % ((j,)+resA), 1)
            

        (averDefAccTr, averAccTr, averPreTr, averRecTr, averDefAccTe, averAccTe, averPreTe,averRecTe,averAUCTr,averAUCTe) = map(lambda x: x*1.0/allCount, (sumDefAccTr,sumAccTr,sumPreTr,sumRecTr,sumDefAccTe,sumAccTe,sumPreTe,sumRecTe,sumAUCTr,sumAUCTe))
        self.printHeader("averages",1)
        self.printInfo("av\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f" % (averDefAccTr, averAccTr, averPreTr, averRecTr, averDefAccTe, averAccTe, averPreTe,averRecTe,averAUCTr,averAUCTe),1)

        i=1
        sumAcc = 0.0
        self.printHeader('Accuracies',1)
        for acc in accuracies:
            sumAcc += acc
            self.printInfo("Acc (i = %s) = %5.2f" % (i,acc),1)
            i += 1
        self.printInfo("AvrgAcc = %5.2f)"% (sumAcc*1.0/allCount), 1)

        i=1
        self.printHeader('Times',1)
        for t in times:
            self.printInfo("Time (i =%2s) = %10s s" % (i,t),1)
            i += 1

        if self.produceRocFiles():
            rocAvgTrain = self.averageRocCurves(rocCurvesTrain)
            appendixTrain  = "_train_average" 
            rocFileNameTrain  = self.getRocFileName(appendix=appendixTrain)
            self.writeRocData(rocFileNameTrain, rocAvgTrain)
            self.writeRocGnuplotCommands('train',allCount)
            
            rocAvgTest = self.averageRocCurves(rocCurvesTest)
            appendixTest  = "_test_average" 
            rocFileNameTest  = self.getRocFileName(appendix=appendixTest)
            self.writeRocData(rocFileNameTest, rocAvgTest)
            self.writeRocGnuplotCommands('test',allCount)

            
        if dbFileNameI == 'arff':
            # removes temporary smiles files
            self.cleanupInputFiles([dbFileNameA, dbFileNameI])
        
            
    def IREP(self, dbNumA, dbNumI, maxErrorRate=50.0, splitPercentage=0.33333, minNumSeeds = 10, beamSize=10, dataFormatter=None):

        li = Lists()        
        matcher = self.getMatcher()
        
        currentPos = matcher.getCurrentMatchSet(dbNumA)
        currentNeg = matcher.getCurrentMatchSet(dbNumI)
        ruleSet = []

        numSeeds=minNumSeeds

        redoCount = 0

        while(len(currentPos) > 0):
            matcher.resetBuffers()
            currentPos = matcher.getCurrentMatchSet(dbNumA)
            currentNeg = matcher.getCurrentMatchSet(dbNumI)
            
            self.printInfo('Pos = %s, Neg = %s, RatioPos = %5.2f' % (len(currentPos), len(currentNeg), (len(currentPos)*1.0/(len(currentPos)+len(currentNeg)))),2)
            (growPos, growNeg, prunePos, pruneNeg) = self.splitExampleSets(currentPos, currentNeg, splitPercentage)


            if (len(prunePos)==0 or len(pruneNeg)==0):
                self.printInfo('#prunePos = %s\t#pruneNeg = %s ' % (prunePos,pruneNeg),5)
                self.printInfo('No prunning examples ',5)
                return ruleSet


            if len(growPos) < numSeeds:
                self.printInfo("numSeeds = %s" % numSeeds,5)
                self.printInfo("len(growPos) = %s" % len(growPos) ,5)
                if len(growPos) > 0:
                    numSeeds = len(growPos)
                else:
                    #numSeeds = len(growPos)
                    self.printInfo('Not enough seeds! Will stop (pos = %s)' % len(growPos),5)
                    return ruleSet

            self.printInfo('growPos = %s, growNeg = %s, RatioPos = %5.2f' % (len(growPos), len(growNeg), (len(growPos)*1.0/(len(growPos)+len(growNeg)))),2)
            self.printInfo('prunePos = %s, pruneNeg = %s, RatioPos = %5.2f' % (len(prunePos), len(pruneNeg), (len(prunePos)*1.0/(len(prunePos)+len(pruneNeg)))),2)

            seeds = li.randList(growPos, numSeeds) # take some seeds
            
            if numSeeds>0:

                actualMinPos = 0
                if self.minPosSet:
                    actualMinPos = self.getMinPos()
                    newMinPos = round(actualMinPos*splitPercentage+0.5)
                    self.printInfo("newMinPos = %s" % newMinPos,6)
                    self.setMinPos(newMinPos)
                    

                #### GROWING #####
                self.printHeader('Going to GROW on %s seeds' % (len(seeds)),2)
                rules = self.growRulesUsingSeeds(dbNumA, dbNumI, growPos, growNeg, seeds, beamSize=beamSize, dataFormatter=dataFormatter)
                self.printHeader('Rules from GROW on %s seeds' % (len(seeds)),2)
                self.printRulesNewType(rules,2)

                #debug:
                #tRule = rules[0]
                #for i in range(len(tRule['patterns'])):
                #    print i,len(tRule['matchingLA'][i]),tRule['matchingLA'][i]
                

                #### PRUNNING ####
                prunedRule = None


                if rules:
                    if self.minPosSet():
                       newMinPos = round(actualMinPos*(1-splitPercentage)+0.5)
                       self.printInfo("newMinPos = %s" % newMinPos,6)
                       self.setMinPos(newMinPos)

                    prunedRules = self.pruneRulesUsingSeeds(dbNumA, dbNumI, prunePos, pruneNeg, rules)

                    self.setMinPos(actualMinPos)
                                      
                    self.printHeader('All Pruned Rules',2)
                    self.printRulesNewType(prunedRules,2)
                    # if there where prunned rules, just take the best one
                    if prunedRules:

                        #prunedRules.sort(sortRules)
                        #prunedRule = prunedRules[0]

                        matcher.setCurrentMatchSet(dbNumA, currentPos)
                        matcher.setCurrentMatchSet(dbNumI, currentNeg)
                        
                        coveredRules = []
                        for prunedRule in prunedRules:
                            #self.printHeader('Pruned and Covered Rules',4)
                            #self.printRulesNewType([prunedRule],4)
                            [cR] = self.rescoreRuleOnFullSet(dbNumA, dbNumI, [prunedRule])
                            #self.printRulesNewType([cR],4)
                            coveredRules.append(cR)
                        self.printHeader('Rescored Pruned Rules on Full Set',2)
                        self.printRulesNewType(coveredRules,2)
                        coveredRules.sort(sortRules)

                        # take only the covered rules covering more than one example
                        coveredRule = None
                        for cr in coveredRules:
                            seLengs = len(cr['matchingA'])
                            #print seLengs,cr['patterns']
                            if (not coveredRule) and (seLengs >= self.getMinPos()):
                                #print "chosen"
                                coveredRule  = cr

                        # didn't find a rule covering more than one positive example
                        if not coveredRule:
                            self.printInfo("didn't find a rule covering more than one positive example",5)
                            return ruleSet
                                  
                    else:
                        self.printInfo("WILL RETURN RULE SET DID'T have PrunedRules", numSeeds,5)
                        return ruleSet
                        
                    self.printHeader('Pruned Rule',2)

                    self.printHeader('Rule for Retracting Examples ',2)
                    self.printRulesNewType([coveredRule],2)

                    tp = len(coveredRule['matchingA'])
                    fp = len(coveredRule['matchingI'])

                    if (tp >= self.getMinPos() or fp <= self.getMaxNeg):
                    

                        divE = tp+fp
                        if divE != 0:
                            errorRate = fp*100.0/divE
                            self.printInfo('errorRate = %5.2f ' %  errorRate,3)
                            if errorRate > maxErrorRate:
                                #print 'currentPos = %s minNumSeeds=%s' % (currentPos, minNumSeeds)
                                if redoCount > 0 or len(currentPos)<=minNumSeeds:
                                    self.printInfo('Error rate (%s > %s) too high returning rules set' % (errorRate,maxErrorRate),5)
                                    return ruleSet
                                else:
                                    # redo 
                                    redoCount = 1
                            else:
                                if redoCount > 0:
                                    self.printInfo('\nREDOSUCCESS!\n',2)
                                    
                                redoCount = 0
                                ruleSet.append(coveredRule)
                                self.retractSamplesCovered(dbNumA, dbNumI, [coveredRule])
                                
                            self.freeFragments([coveredRule])
                            

                        else:
                            self.printHeader('Last Rule skipped as no pos not negs',2)
                    else:
                        self.printHeader('Last Rule as violation to min_pos or max_negs',2)
                
                if self.minPosSet():
                    actualMinPos = self.getMinPos()
                    self.setMinPos(actualMinPos)

                self.printHeader('***',2)
                self.printInfo('\n\n',2)
                currentPos = matcher.getCurrentMatchSet(dbNumA)
                currentNeg = matcher.getCurrentMatchSet(dbNumI)
            else:
                
                self.printInfo("WILL RETURN RULE SET numSeeds", numSeeds,5)
                return ruleSet

        # found perfect rule
        self.printInfo("found perfect rule",5)
        
        return ruleSet

    def rescoreRuleOnFullSet(self, dbNumA, dbNumI, prunedRules):
        coveredRules = []

        for prunedRule in prunedRules:
            coveredRule = self.copyRule(prunedRule)
            self.scoreRuleFromPrunning(dbNumA, dbNumI, coveredRule)
            coveredRules.append(coveredRule)        

        return coveredRules
       

    def retractSamplesCovered(self, dbNumA, dbNumI, coveredRules):

        matcher = self.getMatcher()
        for coveredRule in coveredRules:
            matcher.subtractSet(dbNumA,coveredRule['matchingA'])
            matcher.subtractSet(dbNumI,coveredRule['matchingI'])

    def freeFragments(self,coveredRules):
        # keeps the rules involved in the current rule - all others are deleted
        li = Lists()
        allRoots = []
        for coveredRule in coveredRules:
            frags = coveredRule['fragments']
            if frags:
                while(None in frags):
                    frags.remove(None)
                roots = map(lambda x: x.getRoot(),frags)
                roots = li.uniq(roots)
                allRoots += roots

        self.globalFragsUsed += allRoots
        for rootFrag in self.globalFrags:
            if rootFrag not in allRoots:
                #print "rootFrag ",rootFrag
                #print type(rootFrag)
                rootFrag.__del__()
        self.globalFrags = []

    def pruneRulesUsingSeeds(self, dbNumA, dbNumI, prunePos, pruneNeg, rules):
        if rules:

            bestRules = []
            
            # save match sets
            matcher = self.getMatcher()
            saveCurrentSetA = matcher.getCurrentMatchSet(dbNumA)
            saveCurrentSetI = matcher.getCurrentMatchSet(dbNumI)
            matcher.setCurrentMatchSet(dbNumA,prunePos)
            matcher.setCurrentMatchSet(dbNumI,pruneNeg)


            for rule in rules:
                bestRules.append(self.pruneRuleUsingSeeds(dbNumA, dbNumI, rule))

            # restore old match sets
            matcher.setCurrentMatchSet(dbNumA,saveCurrentSetA)
            matcher.setCurrentMatchSet(dbNumI,saveCurrentSetI)

            #return bestRules[0]
            return bestRules
            
            
    def pruneRuleUsingSeeds(self, dbNumA, dbNumI, rule):
        if not rule:
            return []

        self.scoreRuleFromPrunning(dbNumA, dbNumI, rule)
        self.printHeader('DEBUG starting rule',6)
        self.printRulesNewType([rule],6)

        s = re.compile('\S')
        li = Lists()
        do = 1

                
        #newRule = self.copyRule(rule)
        #prunedRules = [newRule]
        prunedRules = []

        firstTimeRound = 1
        while(do):
            lastMoves = rule['history'][len(rule['history'])-1]
            once = 1
            # added count to avoid overpruning
            count = 5
            # added count to avoid overpruning
            while((lastMoves and rule['fragments']) and count > 0):
                count = count - 1
                #self.printHeader('DEBUG',3)
                #self.printRulesNewType(prunedRules,3)
                lenLastMoves = len(lastMoves)
                lastMove = lastMoves[lenLastMoves-1]
                lastNumerical      = rule['numerical'][len(rule['numerical'])-1]

                if lenLastMoves > 1 and once:
                    newRule = self.copyRule(rule)
                    prunedRules.append(newRule)
                    #self.printHeader('DEBUG ONCE',3)
                    #self.printRulesNewType(prunedRules,3)
                    once = 0
                   
                
                if lastMove:
                    lenLastMove   = len(lastMove)
                    newPatternInt = None
                    newFrag       = None
                    #if len(rule['fragments'])-1 != len(rule['numerical'])-1:
                    #    raise 'Unequal !!'
                    lastFrag      = rule['fragments'][len(rule['fragments'])-1]
                    if lenLastMoves>1: # has more than one last move, resulting from traversal

                        previousLastMove = lastMoves[len(lastMoves)-2]                        
                        if lenLastMove>1: # was ac ab ca ba
                            #self.printInfo('was ac ab ca ba, new pattern , frag stays the same'
                            newPatternInt = lastFrag.getKidLabel(previousLastMove).getData()
                            newFrag = lastFrag
                        else:
                            components = s.findall(previousLastMove)
                            newFrag = lastFrag.getKidLabel(lastMove)
                            if previousLastMove == 'ab' or previousLastMove == 'ba':
                                fragA = newFrag.getKidLabel('a')
                                fragB = newFrag.getKidLabel('b')
                                if fragA and fragB:
                                    newPatternInt = fragA.getData()+'('+fragB.getData()+')'
                                else:
                                    self.printInfo("PROBLEMS!!!AB",5)
                            elif previousLastMove == 'ac' or previousLastMove == 'ca':
                                fragA = newFrag.getKidLabel('a')
                                fragC = newFrag.getKidLabel('c')
                                if fragA and fragC:
                                    newPatternInt = fragA.getData()+fragC.getData()
                                else:
                                    self.printInfo("PROBLEMS!!!AC",5)
                            else:
                                self.printInfo("BIG PROBLEMS!!!Neither AC nor AB",5)
                    else: # resulting from lengthening
                        if lastNumerical:
                            #print 'lastNumerical'
                            #print 'lastFrag,lastmove',lastFrag,lastMove
                            #print rule
                            newPatternInt =  None
                        elif lastMove is not 'u':
                            #print 'lastMove is not u'
                            newPatternInt = lastFrag.getKidLabel(lastMove).getData()
                        else:
                            #print 'lastMove  u'
                            #Hmmm ?
                            #self.printInfo('lenLastMoves',lenLastMoves
                            newPatternInt =  None
                        newFrag = lastFrag
                    rule['fragments'][len(rule['fragments'])-1] = newFrag

                    if newPatternInt: # in case it was a root node
                        #print 'updating'
                        self.updateLastFragement(dbNumA, dbNumI, rule, newPatternInt)
                    
                    

                    if lenLastMoves>1: # had more than one last move, going to delete last move
                        lastMoves.pop()
                        newRule = self.copyRule(rule)
                        prunedRules.append(newRule)
                    else: # was last in moves, delete corresponding history entry and fragments, pattern, ...
                        newRule = self.copyRule(rule)
                        prunedRules.append(newRule)
                        rule['history'].pop()
                        rule['patterns'].pop()
                        rule['matchingLA'].pop()
                        rule['matchingLI'].pop()
                        rule['fragments'].pop()
                        rule['numerical'].pop()
                    # reset last Moves to current value
                    if not rule['history']:
                        lastMoves = []
                        lenLastMoves = 0
                    else:
                        lastMoves = rule['history'][len(rule['history'])-1]
                        lenLastMoves = len(lastMoves)
                    self.printInfo('********** after doing stuff ************',6)
                    self.printInfo('len A %s\tlen I %s\n' % (len(rule['matchingA']),len(rule['matchingI'])),6)
                    if rule['patterns'] != []:
                        self.printRulesNewType([rule],6)
                        self.scoreRuleFromPrunning(dbNumA, dbNumI, rule)
                        self.printRulesNewType([rule],6)

                    firstTimeRound = 0

            # added count to avoid overpruning
            if not rule['history'] or count < 1:
                do = 0

    
        prunedRules = self.removeRuleDoubles(prunedRules,full=1)
        if len(prunedRules) > 1: # more than one? Sort them
            prunedRules.sort(sortRules)
        self.printHeader('Pruned Rules (sorted)',4)
        self.printRulesNewType(prunedRules,4)
        return prunedRules[0]
                        
                        
            
                
    def copyRule(self, rule):
        newRule = {}
        newRule['patterns']   = rule['patterns'] + []
        newRule['matchingA']  = rule['matchingA'] + []
        newRule['matchingI']  = rule['matchingI'] + []
        newRule['fragments']  = rule['fragments'] + []
        newRule['score']      = rule['score'] 
        newRule['label']      = rule['label'] 
        newRule['matchingLA'] = []
        newRule['matchingLI'] = []
        newRule['history']    = []
        newRule['numerical'] = rule['numerical'] + []
        for i in range(len(rule['history'])):
            newRule['history'].append(rule['history'][i]+[])
        for i in range(len(rule['matchingLA'])):
            newRule['matchingLA'].append(rule['matchingLA'][i]+[])
        for i in range(len(rule['matchingLI'])):
            newRule['matchingLI'].append(rule['matchingLI'][i]+[])

        return newRule


    def updateLastFragement(self, dbNumA, dbNumI, rule, patternInt):
        li = Lists()
        (newScore, newMatchingA, newMatchingI) = (None,None,None)
        if patternInt != 'num':
            pattern = self.convertBackToSmiles(patternInt)
            (newScore, newMatchingA, newMatchingI) = self.scoreRuleFragmentFromPrunning(dbNumA, dbNumI, pattern,1)
        else:
            (newScore, newMatchingA, newMatchingI) = self.scoreRuleBinFromPrunning(dbNumA, dbNumI, rule['patterns'][i],1)
            
        
        rule['patterns'][len(rule['patterns'])-1] = pattern
        rule['matchingLA'][len(rule['matchingLA'])-1] = newMatchingA
        rule['matchingLI'][len(rule['matchingLI'])-1] = newMatchingI

        matchingA = rule['matchingLA'][0]
        matchingI = rule['matchingLI'][0]

        for i in range(len(rule['patterns'])-1):
            matchingA = li.intersection(matchingA,rule['matchingLA'][i+1]) 
            matchingI = li.intersection(matchingI,rule['matchingLI'][i+1])

        rule['matchingA'] = matchingA
        rule['matchingI'] = matchingI


        matcher = self.getMatcher()
        Pos = self.getMatcher().getCurrentMatchSet(dbNumA)
        Neg = self.getMatcher().getCurrentMatchSet(dbNumI)
        #score = self.compute_v(len(matchingA),len(matchingI) , len(Pos), len(Neg))
        #print "updateLastFragement"
        score = self.calculateHeuristic(len(matchingA),len(matchingI) , len(Pos), len(Neg))
        rule['score'] = score
                    

    def growRulesUsingSeeds(self, dbNumA, dbNumI, growPos, growNeg, seeds, beamSize=10, dataFormatter=None):
        if seeds:
            matcher = self.getMatcher()
            # save current match sets and store growing ones
            saveMatchSetA = matcher.getCurrentMatchSet(dbNumA)
            saveMatchSetI = matcher.getCurrentMatchSet(dbNumI)
            matcher.setCurrentMatchSet(dbNumA, growPos)
            matcher.setCurrentMatchSet(dbNumI, growNeg)


            currenBestRules = []
            for seed in seeds:
                currentRule = self.growRuleFromSeed(dbNumA, dbNumI, growPos, growNeg, seed, beamSize=beamSize, dataFormatter=dataFormatter)
                if currentRule != []:
                    currenBestRules.append(currentRule)
                #self.getRelation().printHashUsage()

            return currenBestRules

            currenBestRules.sort(sortRules)
            tempBestRule = currenBestRules[0]
            for bRule in currenBestRules:
                if bRule != []:
                    tempBestRule = bRule
                    break

            bestRule = tempBestRule

            # get all rules with 'best score'
            bestRuleScore = tempBestRule['score']
            if len(currenBestRules) > 1:
                try:
                    allBest = filter(lambda x: x['score']==bestRuleScore, currenBestRules)
                except:
                    self.printInfo("Error",5)
                    self.printInfo( bestRuleScore,5)
                    self.printInfo( tempBestRule,5)
                    self.printInfo( currenBestRules,5)
                    
            
                self.printHeader('All Best Rules', 3)
                self.printRulesNewType(allBest, 3)

                # select one randomly
                
                #random.seed(20)
                bestRule = allBest[random.randrange(len(allBest))]
            else:
                bestRule = tempBestRule

            bestRule = tempBestRule
                
            # save matche sets back
            matcher.setCurrentMatchSet(dbNumA, saveMatchSetA)
            matcher.setCurrentMatchSet(dbNumI, saveMatchSetI)            
            #return bestRule
            return currenBestRules

        return None

    def growRuleFromSeed(self, dbNumA, dbNumI, growPos, growNeg, seed, kP=0.02, beamSize=10, dataFormatter=None):
        matcher = self.getMatcher()
        li = Lists()
        entryString = ''
        dbEntriesA = growPos
        entryString = None
        numAttributes = {}
        relation      = None
        if dataFormatter:
            # stores all numercal attribute names as dictionary
            relation = self.getRelation()
            numAttributes = dict(map(lambda x: (x,None), relation.getNumericalAttributes()))
        
        try :
            entryString =  matcher.getBestEntry(dbNumA, seed)
        except:
            # in cases the entry cannot be fount by itself
            return []
        if entryString:
            comment = matcher.getEntryComment(dbNumA, seed)
            if comment:
                self.printInfo('Seed = %s (%s)\t%s' % (seed, comment, entryString),2)
            else:
                self.printInfo('Seed = %s\t%s' % (seed, entryString),2)
                
            # if has ionic bonds (aka disconnections '.')
            entryStrings = entryString.split('.')
            roots = []
            minNeg = 0
            negLocals = []
            posLocals = []
            for entryS in entryStrings:
                root = self.compile(entryS)
                self.globalFrags.append(root)
                roots = roots + [root]
                
                #posLocals.append(matcher.getMatching(dbNumA,entryS))
                #negLocals.append(matcher.getMatching(dbNumI,entryS))

            minNeg = 0
            #minNeg = len(negsL)
            #self.printInfo('minNeg = %s' % minNeg
            #self.printInfo('maxPos = %s' %  len(possL)

            # get all ground fragments            
            fragments    = []
            bins         = []
            for root in roots:
                # use all patterns
                fragments = fragments + root.getLeaves()

            # to use functional groups
            #fragments = fragments + self.fg.getNodes()
                
            if dataFormatter:
                for att in numAttributes.keys():
                    value = relation.getValue(att,'active', seed, )
                    binAtts = relation.getBinAttribute(att,value)
                    for b in binAtts:
                        (label,value) = string.split(b,':')
                        newNode = Node(value,None,1,1,[])
                        newNode.setLabel(label)
                        newNode.setNumerical()
                        bins.append(newNode)

            #self.printInfo('numFragments = %s ' %  len(fragments)

            currentRules = []
            count = 1

            kTemp = int(kP*len(fragments))

            #k = kTemp
            #
            #if kTemp<beamSize:
            #    k = beamSize

            k=beamSize

            # have to select random fragments,
            #'O1C2OC3C(OC(OC4C(OC(OC5C(OC(OC6C(OC(OC7C(OC(OC8C(OC(OC(C1CSCC)C(C2OS(=O)(=O)O)OS(=O)(=O)O)C(C8OS(=O)(=O)O)OS(=O)(=O)O)CSCC)C(C7OS(=O)(=O)O)OS(=O)(=O)O)CSCC)C(C6OS(=O)(=O)O)OS(=O)(=O)O)CSCC)C(C5OS(=O)(=O)O)OS(=O)(=O)O)CSCC)C(C4OS(=O)(=O)O)OS(=O)(=O)O)CSCC)C(C3OS(=O)(=O)O)OS(=O)(=O)O)CSCC'
            # generates over 9000 ground frags

            origFrags = fragments
            lenOrigFrags = len(origFrags)
            if lenOrigFrags  > 1000:
                fragments = li.randList(origFrags,1000)

            # construct "empty" rule, no conj, not pattern, true for all poss and negs
            prevRule = {'matchingA':growPos, 'matchingI':growNeg}
            
            for fragment in fragments:
                rule = None
                label = fragment.getLabel()
                #self.printInfo(count, label, fragment.getData()
                count += 1
                if label != 'u':
                    (pattern, score, matchingA, matchingI) = self.getPatternScoreAndMatching(dbNumA, dbNumI, fragment.getParent(), fragment.getLabel(), prevRule)
                    rule = {'score':score,'matchingA':matchingA,'matchingLA':[matchingA],'matchingI':matchingI,'matchingLI':[matchingI], 'fragments':[fragment.getParent()], 'patterns':[pattern], 'label':fragment.getLabel(), 'history':[[fragment.getLabel()]], 'numerical':[0]}
                    #self.printInfo(fragment.getLabel(), fragment.getData(), pattern

                else: # is root
                    (pattern, score, matchingA, matchingI) = self.getPatternScoreAndMatching(dbNumA, dbNumI, fragment, fragment.getLabel(), prevRule)
                    rule = {'score':score,'matchingA':matchingA,'matchingLA':[matchingA],'matchingI':matchingI,'matchingLI':[matchingI], 'fragments':[fragment.getParent()], 'patterns':[pattern], 'label':fragment.getLabel(), 'history':[[fragment.getLabel()]], 'numerical':[0]}
                    #self.printInfo(fragment.getLabel(), fragment.getData(), pattern
                # ak here
                currentRules.append(rule)

            #for bin in bins:
            for bin in []:
                rule = None
                (pattern, score, matchingA, matchingI) = self.getBinScoreAndMatching(bin, None, prevRule, relation)
                #print pattern,score
                rule = {'score':score,'matchingA':matchingA,'matchingLA':[matchingA],'matchingI':matchingI,'matchingLI':[matchingI], 'fragments':[bin], 'patterns':[pattern], 'label':bin.getLabel(), 'history':[[bin.getLabel()]],'numerical':[1]}
                currentRules.append(rule)

                
            #self.printRulesNewType(currentRules,1)
            currentRules.sort(sortRules)

            previousRoundRules = [prevRule]
                
            iteration = 0
            stop = 0
            while(not stop):
                #print "ITERATION %s" % (iteration)
                    
                # if more than 1000, select ranom fragments for lengthening
                #print "lenOrigFrags = %s" % lenOrigFrags
                if lenOrigFrags  > 2000:
                    fragments = li.randList(origFrags,2000)
                    
                if len(currentRules) > 2000:
                    #just take max 2000 rules
                    lenTen = int(len(currentRules)*0.1)
                    currentRules = li.randList(currentRules,200)
                    
                currentRules = self.removeRuleDoubles(currentRules)
                currentRules.sort(sortRules)
                
                
                iteration += 1
                if iteration >5 and len(currentRules) >0: # just for info
                    self.printInfo('Iteration: %s (%s:%s)' % (iteration, len(currentRules[0]['matchingA']), len(currentRules[0]['matchingI'])),5)
                
                #taking only the k-best rules (if possible)
                #self.printInfo("NUMBER PF RULES = %s\tk=%s" % (len(currentRules),k)
                if self.degradeBeam:
                    keep = k+64/(2**iteration)
                    if len(currentRules) > keep:
                        
                        print keep, currentRules[0]['score'], currentRules[keep]['score']
                        currentRules = currentRules[:keep]
                    else:
                        print len(currentRules), currentRules[0]['score'], currentRules[len(currentRules)]['score']
                else:
                    if len(currentRules) > k:
                        currentRules = currentRules[:k]

                #stop growing rules (eiher no more inactives, or minneg has been reached or no improvement)
                if (len(currentRules[0]['matchingI']) == 0) or (len(currentRules[0]['matchingI']) == minNeg) or (len(currentRules[0]['matchingI']) >= len(previousRoundRules[0]['matchingI'])):
                    if (len(currentRules[0]['matchingI']) > len(previousRoundRules[0]['matchingI'])):
                        return previousRoundRules[0]
                    return currentRules[0]
                else:
                    previousRoundRules = currentRules


                newRules = []
                lengthyOnes = []
                
                for rule in currentRules:
                    newRulesFromTraversal = []

                    if not rule['numerical'][len(rule['numerical'])-1]: # only refine if last element wasn't numerical
                        newRulesFromTraversal   = self.refineFragment(rule)
                        newRulesFromTraversal   = self.scoreNewRules(dbNumA, dbNumI, newRulesFromTraversal, rule,1)
                    if newRulesFromTraversal:
                        newRules = newRules + newRulesFromTraversal

                    newRulesFromLengthening = []
                    newRulesFromLengthening = self.addConstraintsToRule(rule, fragments)
                        
                    if len(filter(lambda x:x>0,map(lambda x: len(x),rule['history']))) > 0:
                        # add numericals
                        newRulesFromLengthening = newRulesFromLengthening+self.addConstraintsToRule(rule, bins)

                    #debug find clac Heuristics
                    if newRulesFromLengthening:
                        newRulesFromLengthening = self.scoreNewRules(dbNumA, dbNumI, newRulesFromLengthening, rule,1)                        
                        newRules = newRules + newRulesFromLengthening 
                        #lengthyOnes = lengthyOnes + newRulesFromLengthening 

                currentRules = newRules
        else:
            self.printInfo('Seed number %s is not save for exploration' % seed, 2)
       
    def addConstraintsToRule(self, rule, fragments):
        newRules = []
        for frag in fragments:
            #self.printInfo(fragment.getData()
            parent = frag.getParent()
            
            if parent:
                newFragments = rule['fragments'] + [frag.getParent()]
            else: # exeptions for ionic bonds
                newFragments = rule['fragments'] + [frag]
            newHistory   = rule['history'] + [[frag.getLabel()]]
            newPatterns  = rule['patterns'] + [] # forces a copy
            newMatchingLA  = rule['matchingLA'] + []
            newMatchingLI  = rule['matchingLI'] + []
            newNumerical   = rule['numerical']  + [frag.isNumerical()]
            
            newRule = {'fragments':newFragments, 'label':frag.getLabel(), 'history':newHistory, 'patterns':rule['patterns'], 'patterns':newPatterns , 'matchingLA': newMatchingLA, 'matchingLI': newMatchingLI, 'numerical':newNumerical}
            newRules.append(newRule)
        return newRules

    def refineFragment(self, rule):
        newRules = []

        if not rule['numerical'][len(rule['numerical'])-1]: #smarts fragment
            # takes of last fragment of fragment list
            lastFragment = rule['fragments'][len(rule['fragments'])-1]
            if not lastFragment:
                return []
            curType      = rule['label']
            curSubType = None
            if lastFragment.getLabel() != 'u': #not root node
                lastIndex = len(rule['history'])-1
                lastHistoryElement =  rule['history'][lastIndex]
                if curType and len(curType) == 1: # go and explore subtypes
                    curSubType = self.getNextRefinementType(curType, curSubType)
                    while curSubType:
                        newFragments = rule['fragments'][:lastIndex]+[lastFragment]
                        newHistory   = []+rule['history'][:lastIndex] + [lastHistoryElement + [curSubType]]
                        newPatterns  = rule['patterns'][:lastIndex] + [] # forces a copy
                        newMatchingLA  = rule['matchingLA'][:lastIndex] + []
                        newMatchingLI  = rule['matchingLI'][:lastIndex] + []
                        newNumerical = rule['numerical']+[]
                        newRule = {'fragments':newFragments, 'label':curSubType, 'history':newHistory, 'patterns':newPatterns , 'matchingLA': newMatchingLA, 'matchingLI': newMatchingLI, 'numerical':newNumerical}
                        newRules.append(newRule)
                        curSubType = self.getNextRefinementType(curType, curSubType)
                else:
                     #have to move up in the tree
                     newFragments = rule['fragments'][:lastIndex]+[lastFragment.getParent()]
                     newHistory   = rule['history'][:lastIndex] + [lastHistoryElement + [lastFragment.getLabel()]]
                     newPatterns  = rule['patterns'][:lastIndex] + [] # forces a copy
                     newMatchingLA  = rule['matchingLA'][:lastIndex] + []
                     newMatchingLI  = rule['matchingLI'][:lastIndex] + []
                     newNumerical = rule['numerical']+[]
                     newRule = {'fragments':newFragments, 'label':lastFragment.getLabel(), 'history':newHistory, 'patterns':newPatterns , 'matchingLA': newMatchingLA, 'matchingLI': newMatchingLI, 'numerical':newNumerical}
                     newRules.append(newRule)

        return newRules

    def removeRuleDoubles(self, rules,full=None):
        if rules:
            returnRules = []
            for rule in rules:
                found = 0;
                for retRule in returnRules:
                    if (full):
                        #self.printRulesNewType([retRule ,rule],3)
                        #print "COMP = %s" % cmpRuleFull(retRule ,rule)
                        if cmpRuleFull(retRule ,rule) == 0:
                            found = 1
                    else:
                        if cmpRule(retRule ,rule) == 0:
                             found = 1
                       
                #if rule not in returnRules:
                if not found:
                    returnRules.append(rule)
            return returnRules
        return []
            


    def printRulesNewType(self, rules, num):
        count = 1
        if rules:
            for rule in rules:
                self.printRuleNewType(rule, num, count)
                count += 1
        else:
            self.printInfo("\nNo rules found!\n",1)
           
                
    def printRuleNewType(self, rule, num, count = 0):
        countString = ''
        if count:
            countString = "%3d\t" % count
        
        self.printInfo('%sScore %4.5f\tPos: %4s\tNeg: %4s\tFragments: %3s\tpatterns  %s\tHistory  %s\t Num: %s' % (countString, rule['score'], len(rule['matchingA']),len(rule['matchingI']),len(rule['fragments']),rule['patterns'],rule['history'], rule['numerical']),num)

    def getRulesAsString(self, rules, format='readable'):
        returnRulesString = ""
        count = 1
        for rule in rules:
            returnRulesString = returnRulesString +  self.getRuleAsString(rule, count, format) + '\n'
            count += 1
        return returnRulesString
    
    def getRuleAsString(self, rule, count=0, format='readable'):
        returnString = ''
        countString = ''
        if count:
            countString = "%3d\t" % count
        if format == 'readable':
            returnString = '%sScore %4.5f\tPos: %4s\tNeg: %4s\tFragments: %3s\tpatterns  %s\tHistory  %s' % (countString, rule['score'], len(rule['matchingA']),len(rule['matchingI']),len(rule['fragments']),rule['patterns'],rule['history'])
        elif format == 'prolog':
            if self.relationSet():
                rel = self.getRelation()
                namesA = map(lambda x: rel.getAttribute(x,'active'),rule['matchingA'])
                namesI = map(lambda x: rel.getAttribute(x,'inactive'),rule['matchingI'])
                returnString = 'rule(%d,%s,%s,%f,%s,%s).' % (count, rule['patterns'], rule['history'], rule['score'], namesA, namesI)
            else:
                returnString = 'rule(%d,%s,%s,%f,%s,%s).' % (count, rule['patterns'], rule['history'], rule['score'], rule['matchingA'], rule['matchingI'])
        elif format == 'csv': # ish, we use tabs instead
            if self.relationSet():
                rel = self.getRelation()
                namesA = map(lambda x: rel.getAttribute(x,'active'),rule['matchingA'])
                namesI = map(lambda x: rel.getAttribute(x,'inactive'),rule['matchingI'])
                returnString = '%d\t%s\t%s\t%f\t%s\t%s' % (count, rule['patterns'], rule['history'], rule['score'], namesA, namesI)
            else:
                returnString = '%d\t%s\t%s\t%f\t%s\t%s' % (count, rule['patterns'], rule['history'], rule['score'], rule['matchingA'], rule['matchingI'])
        return returnString
            

    def getPreRec(self, results):
        #print results
        (resTr,resTe,AUCs) = results
        defAccTr  = 100.0*(resTr[1]+resTr[2])/(resTr[0]+resTr[1]+resTr[2]+resTr[3])
        if defAccTr< 50.0: #use majority class
            defAccTr  = 100.0*(resTr[0]+resTr[3])/(resTr[0]+resTr[1]+resTr[2]+resTr[3])
        accTr     = 100.0*(resTr[0]+resTr[2])/(resTr[0]+resTr[1]+resTr[2]+resTr[3])
        recTr     = self.recall(resTr[0],resTr[3])
        preTr     = self.precision(resTr[0],resTr[1])
        defAccTe  = 100.0*(resTe[1]+resTe[2])/(resTe[0]+resTe[1]+resTe[2]+resTe[3])
        if defAccTe< 50.0: #use majority class
            defAccTe  = 100.0*(resTe[0]+resTe[3])/(resTe[0]+resTe[1]+resTe[2]+resTe[3])
        accTe     = 100.0*(resTe[0]+resTe[2])/(resTe[0]+resTe[1]+resTe[2]+resTe[3])
        recTe     = self.recall(resTe[0],resTe[3])
        preTe     = self.precision(resTe[0],resTe[1])
        return (defAccTr, accTr, preTr, recTr, defAccTe, accTe, preTe, recTe, AUCs[0], AUCs[1])
        
        
    def precision(self,tp,fp):
        if tp+fp>0:
            return (tp*1.0/(tp+fp))
        else:
            return 0.0

    def recall(self,tp,fn):
        if tp+fn>0:
            return (tp*1.0/(tp+fn))
        else:
            return 0.0

    def calculateROCCurve2(self, rules, pos, neg):
        #print pos,neg
        
        tpAbs = 0
        fpAbs = 0
        rawRocData = []

        if not rules:
            return [(0.0,0.0),(1.0,1.0)]
        
        for rule in rules:
            tp = len(rule['matchingA'])
            fp = len(rule['matchingI'])
            # ignore rule if neither pos nor neg (testing data)
            if not (tp == fp == 0):
                # nothing in there yet - add
                if not rawRocData:
                    rawRocData.append((fp+fpAbs,tp+tpAbs))

                # there was only an improvement in Y (another rule fired only for positives)
                elif  fp+fpAbs == fpAbs and tp+tpAbs > tpAbs:
                    rawRocData = rawRocData[:len(rawRocData)-1]
                    rawRocData.append((fp+fpAbs,tp+tpAbs))
                # there was only an improvement in X (only negatives were covered)
                #elif fp+fpAbs >  fpAbs and tp+tpAbs == tpAbs:
                else:
                    # another step in x direction, 
                    rawRocData.append((fp+fpAbs,tp+tpAbs))
            tpAbs += tp
            fpAbs += fp

        rawRocData = map(lambda x: (x[0]*1.0/neg, x[1]*1.0/pos), rawRocData)
        # add lower left corner if necessary
        if rawRocData:
            if rawRocData[0][0] != 0.0:
                rawRocData = [(0.0,0.0)]+rawRocData
        else:
            rawRocData = [(0.0,0.0)]
            
        # add upper right corner if necessary
        if rawRocData[len(rawRocData)-1][0] != 1.0:
            rawRocData = rawRocData+[(1.0,1.0)]
        
        #for i in range(len(rawRocData)):
        #    print "%s\t%s" % (rawRocData[i][0],rawRocData[i][1])

        return rawRocData

    def mergeRocCurves(self, rocs=[]):
        #print rocs
        numRocs = len(rocs)
        lengths = []
        counts  = []
        lastRocPicked = 0

        # only if we have at least two roccurves
        if numRocs>1:
            sumCurrent = 0.0

            # initialise for x = 0.0. Take the average of all curves
            for roc in rocs:
                lengths.append(len(roc))
                counts.append(1)
                sumCurrent += roc[0][1]*1.0
            newRoc = [(0.0,sumCurrent/(numRocs*1.0))]

            # now go and find the lowest x value of all curves not being 0.0. Calculate the right points for that
            # x for all other curves. Take the average y for all curves at that point, and add that to the new
            # roc curve. If to x values are the same, progess in the other curve as well. Do that until we had
            # all x values (apart from 1.0)
            finished = 0
            while(not finished):
                lowest = 1.1
                for i in range(numRocs):
                    if rocs[i][counts[i]][0] < lowest:
                        lowest = rocs[i][counts[i]][0]
                        lastRocPicked = i
                counts[lastRocPicked] += 1
                sumCurrent = 0.0
                for i in range(numRocs):
                    if i != lastRocPicked:
                        (x1,y1) = rocs[i][counts[i]-1]
                        (x2,y2) = rocs[i][counts[i]]
                        y3 = self.getPoint(x1,y1,x2,y2,lowest)
                        sumCurrent += y3

                        # if the xvalues are the same, we have to increase the count
                        if rocs[i][counts[i]][0] == lowest:
                            counts[i] += 1
                    else:
                        sumCurrent += rocs[lastRocPicked][counts[lastRocPicked]-1][1]
                        

                newRoc.append((lowest,sumCurrent/numRocs))
                
                for i in range(numRocs):
                    if counts[i] ==  lengths[i]-1:
                        finished += 1
                # if all x in all curves are used, we are finished
                if finished != numRocs:
                    finished = 0

            # more or less hypothetical case that there is a (1.0,X)
            if newRoc[len(newRoc)-1][0]<1.0:
                newRoc.append((1.0,1.0))
            
            return newRoc
        elif numRocs == 1:
            return rocs[0]
        else:
            return []
        
    

    def getAUC(self,roc):
         if roc:
             auc = 0.0
             for i in range(len(roc)-1):
                 # to calculate a trapeze: x2-x1*(y2+y1)/2                 
                 auc += ((roc[i+1][0]-roc[i][0]))*((roc[i+1][1]+roc[i][1])/2.0)
             return auc
       
    def getPoint(self, x1,y1, x2,y2, x3):

        if (x1<x2):
            return (y2-y1)*x3/(x2-x1) + (1.0*x2*y1-1.0*x1*y2)/(1.0*(x2-x1))
        else:
            return self.getPoint(x2,y2,x1,y1,x3)
        
    def getRocForGnu(self,roc):
        if roc:
            retString = ""
            for i in range(len(roc)):
                retString += "%s\t%s\n" % (roc[i][0], roc[i][1])
            return retString
        
    def calculateROCCurve(self, rules):
        tpAbs = 0
        fpAbs = 0

        rawRocData = [(0.0,0.0)]

        for rule in rules:
            tp = len(rule['matchingA'])
            fp = len(rule['matchingI'])
            rawRocData.append((fp+fpAbs,tp+tpAbs))
            tpAbs += tp
            fpAbs += fp
        # if there no false positives, it is the perfect ROC curve
        if fpAbs == 0:
            return map(lambda x: (x,1.0),map (lambda x: 1.0*x/100,range(101)))

        rawRocData = map(lambda x: (x[0]*1.0/fpAbs, x[1]*1.0/tpAbs), rawRocData)

        rocData = []
        index = 0 
        lastTPRate = 0.0
        for i in range(101):
            fpC = i*1.0/100
            (fp,tp) = rawRocData[index]
            if ((fp <= fpC) and (len(rawRocData)>index+1)) :
                lastTPRate = tp
                index += 1
            rocEntry = (i*1.0/100, lastTPRate)
            rocData.append(rocEntry)

        return rocData


    def averageRocCurves(self, rocCurves):
        if rocCurves:
            avgRocData = map(None, map(lambda x: 0.0, range(101)), map(lambda x: 0.0, range(101)))
            count = 0
            for curve in rocCurves:
                avgRocData = map(None, map(lambda x,y: x[0]+y[0], curve ,avgRocData), map(lambda x,y: x[1]+y[1],curve ,avgRocData))
                count += 1
            avgRocData = map (lambda x: (x[0]/count,x[1]/count), avgRocData)
            return avgRocData

    def writeRocData(self, fileName, rocData):
         if fileName and rocData:
            rocHandle = open(fileName, 'w')
            rocString = self.getRocForGnu(rocData)
            rocHandle.write(rocString)
            rocHandle.close()

    def writeRocGnuplotCommands(self,appendix,k=None):
        if appendix is not None:
            fileName = self.getRocFileName(suffix=None, appendix='_'+appendix)
            plotFileName = fileName+'_gnuplot.cmd' 
            plotF = open(plotFileName,'w')
            plotF.write('plot ')
            if k:
                appendAvg = "_%s_average" % appendix
                fName = self.getRocFileName(appendix=appendAvg)
                plotF.write('"'+fName+'" with lines, ')
                for i in range(k-1):
                    appendK = "_%s_k%s" % (appendix,string.zfill("%s" % (i+1), 2))
                    fName = self.getRocFileName(appendix=appendK)
                    plotF.write('"'+fName+'" with lines, ')
                appendK = "_%s_k%s" % (appendix,string.zfill("%s" % k, 2))
                fName = self.getRocFileName(appendix=appendK)
                plotF.write('"'+fName+'" with lines\n')
            else:
                appendN = "_%s" % appendix
                fName = self.getRocFileName(appendix=appendN)
                plotF.write('"'+fName+'" with lines\n')
            plotF.close()

    def _getBinScoreAndMatching1(self, bin, current, prevRule, relation=None):
        patternInt = None
        label = bin.getLabel()
        condition = bin.getData()

        g  = 4
        #print "label",label
        #print "condition",condition
        conSym = ""
        value = 0.0
        if condition[g] == '>':
            value = condition[g+2:]
            conSym = '>'
        else:
            value = condition[g+3:]
            conSym = '<='

        #print conSym,value

        
        activesN = relation.getCalues(label,(conSym,value),prevRule['matchingA'],'active')
        inactivesN = relation.getCalues(label,(conSym,value),prevRule['matchingI'],'active')

        #print "label ",label
        #print "condition ",condition
        #print "(conSym,value) ",(conSym,value) 
        #print "activesN ",len(activesN)
        
        conditionPlain = condition.replace('#X#',label)
        (score, matchingLA, matchingLI) = self.scoreBinCondition(activesN, inactivesN, prevRule['matchingA'], prevRule['matchingI'],1)

        matchingLAComp = matchingLA
        
        return (conditionPlain, score, matchingLA, matchingLI)

    def _getBinScoreAndMatching2(self, bin, current, prevRule, relation=None):
        patternInt = None
        label = bin.getLabel()
        condition = bin.getData()
        potActiveInt = relation.getBalues(attribute=label,ids = prevRule['matchingA'], internalId='active')
        potInactiveInt = relation.getBalues(attribute=label,ids = prevRule['matchingI'], internalId='inactive')


        activesInt = []
        inactivesInt = []

        
        g  = condition.find('>')
        le = condition.find('<=')
        if g>0:
            value = string.atof(condition[g+1:])
            activesInt = filter(lambda x: potActiveInt[x][label] > value,potActiveInt.keys()) 
            inactivesInt = filter(lambda x: potInactiveInt[x][label] > value,potInactiveInt.keys()) 
        elif le>0:
            value = string.atof(condition[le+2:])
            activesInt = filter(lambda x: potActiveInt[x][label] <= value,potActiveInt.keys()) 
            inactivesInt = filter(lambda x: potInactiveInt[x][label] <= value,potInactiveInt.keys()) 
        else:
            raise "errorssssss"
                
        actives = []
        if activesInt:
            actives = relation.convertToSmipperID('active',activesInt)

        inactives = []
        if inactivesInt:
            inactives = relation.convertToSmipperID('inactive',inactivesInt)

        conditionPlain = condition.replace('#X#',label)

        (score, matchingLA, matchingLI) = self.scoreBinCondition(actives, inactives, prevRule['matchingA'], prevRule['matchingI'],1)

        #tempA = self.li.intersection(matchingLA,prevRule['matchingA'])
        #tempI = self.li.intersection(matchingLI,prevRule['matchingI'])
        
        #print conditionPlain,score, len(prevRule['matchingA']),len(prevRule['matchingI']),len(matchingLA), len(matchingLI),len(tempA),len(tempI)
        #prevRule['matchingA'].sort()
        #activesInt.sort()
        #actives.sort()
        #matchingLA.sort()
        #tempA.sort()
        #print prevRule['matchingA']
        #print potActiveInt
        #print activesInt
        #print actives
        #print matchingLA
        #print tempA
        #print "finishing"
        #sys.exit(0)


        return (conditionPlain, score, matchingLA, matchingLI)

            
    def getBinScoreAndMatching(self, bin, current, prevRule, relation=None):
        ret1 = self._getBinScoreAndMatching1(bin, current, prevRule, relation)
        #ret2 = self._getBinScoreAndMatching2(bin, current, prevRule, relation)

        return ret1
        
        patternInt = None
        label = bin.getLabel()
        condition = bin.getData()

        g  = 4
        #print "label",label
        #print "condition",condition
        conSym = ""
        value = 0.0
        if condition[g] == '>':
            value = condition[g+2:]
            conSym = '>'
        else:
            value = condition[g+3:]
            conSym = '<='

        #print conSym,value

        
        activesN = relation.getCalues(label,(conSym,value),prevRule['matchingA'],'active')
        inactivesN = relation.getCalues(label,(conSym,value),prevRule['matchingI'],'active')

        #print "label ",label
        #print "condition ",condition
        #print "(conSym,value) ",(conSym,value) 
        #print "activesN ",len(activesN)
        
        conditionPlain = condition.replace('#X#',label)
        (score, matchingLA, matchingLI) = self.scoreBinCondition(activesN, inactivesN, prevRule['matchingA'], prevRule['matchingI'],1)

        matchingLAComp = matchingLA
        
        #return (conditionPlain, score, matchingLA, matchingLI)


        # hopefully obsolete
        
        potActiveInt = relation.getBalues(attribute=label,ids = prevRule['matchingA'], internalId='active')
        potInactiveInt = relation.getBalues(attribute=label,ids = prevRule['matchingI'], internalId='inactive')


        activesInt = []
        inactivesInt = []

        
        g  = condition.find('>')
        le = condition.find('<=')
        if g>0:
            value = string.atof(condition[g+1:])
            activesInt = filter(lambda x: potActiveInt[x][label] > value,potActiveInt.keys()) 
            inactivesInt = filter(lambda x: potInactiveInt[x][label] > value,potInactiveInt.keys()) 
        elif le>0:
            value = string.atof(condition[le+2:])
            activesInt = filter(lambda x: potActiveInt[x][label] <= value,potActiveInt.keys()) 
            inactivesInt = filter(lambda x: potInactiveInt[x][label] <= value,potInactiveInt.keys()) 
        else:
            raise "errorssssss"
                
        actives = []
        if activesInt:
            actives = relation.convertToSmipperID('active',activesInt)

        inactives = []
        if inactivesInt:
            inactives = relation.convertToSmipperID('inactive',inactivesInt)

        conditionPlain = condition.replace('#X#',label)

        (score, matchingLA, matchingLI) = self.scoreBinCondition(actives, inactives, prevRule['matchingA'], prevRule['matchingI'],1)

        #tempA = self.li.intersection(matchingLA,prevRule['matchingA'])
        #tempI = self.li.intersection(matchingLI,prevRule['matchingI'])
        
        #print conditionPlain,score, len(prevRule['matchingA']),len(prevRule['matchingI']),len(matchingLA), len(matchingLI),len(tempA),len(tempI)
        #prevRule['matchingA'].sort()
        #activesInt.sort()
        #actives.sort()
        #matchingLA.sort()
        #tempA.sort()
        #print prevRule['matchingA']
        #print potActiveInt
        #print activesInt
        #print actives
        #print matchingLA
        #print tempA
        #print "finishing"
        #sys.exit(0)


        return (conditionPlain, score, matchingLA, matchingLI)

        #print len(prevRule['matchingI'])
        #print potInactive

        #(score, matchingLA, matchingLI) = self.scoreFragmentString(dbNumA, dbNumI, pattern, prevRule['matchingA'], prevRule['matchingI'],1)
        #return (pattern, score, matchingLA, matchingLI)
   

    def getPatternScoreAndMatching(self,dbNumA, dbNumI, fragment, current, prevRule, relation=None):
        patternInt = None
        
        if len(current) == 1 or current.isdigit():
            if current == 'u':
                #self.printInfo('root', current
                frag = fragment
            else:
                #self.printInfo('normal', current
                frag = fragment.getKidLabel(current)
            # for debuging
            if not frag:
                self.printInfo(current, fragment,5)
                self.printInfo(fragment.getParent(),5)
            patternInt = frag.getData()
        else:
            if current == 'ab' or current == 'ba':
                fragA = fragment.getKidLabel('a')
                fragB = fragment.getKidLabel('b')
                if fragA and fragB:
                    patternInt = fragA.getData()+'('+fragB.getData()+')'
                #else:
                #    self.printInfo("NO AB"
            elif current == 'ac' or current == 'ca':
                fragA = fragment.getKidLabel('a')
                fragC = fragment.getKidLabel('c')
                if fragA and fragC:
                    patternInt = fragA.getData()+fragC.getData()
                #else:
                #    self.printInfo("NO AC"
            else:
                self.printInfo(("NO real current"+current),5)
               
                
        if patternInt:
            pattern = self.convertBackToSmiles(patternInt)
            (score, matchingLA, matchingLI) = self.scoreFragmentString(dbNumA, dbNumI, pattern, prevRule['matchingA'], prevRule['matchingI'],1)
            return (pattern, score, matchingLA, matchingLI)
        else:
            #self.printInfo("No pattern!"
            #self.printInfo(current
            return ('', -1000,[-1],[-1])
        
    def scoreNewRules(self, dbNumA, dbNumI, rules, prevRule,use_foil=None):
        li = Lists()
        scoredRules = []
        for rule in rules:
            #print rule
            fragments   = rule['fragments']+[]
            history     = rule['history']+[]
            patterns    = rule['patterns']+[]
            matchingLA  = rule['matchingLA']+[]
            matchingLI  = rule['matchingLI']+[]
            lastElement = len(fragments)-1
            fragment    = fragments[lastElement]
            label       = rule['label']

            (pattern, score, matchingA, matchingI) = (None, None, None, None)
            #            if parent and not fragment.getLabel().isdigit():
            #if label != 'u':
            #if rule.has_key('numerical'):
            if rule['numerical'][lastElement]:
                (pattern, score, matchingA, matchingI) = self.getBinScoreAndMatching(fragment, label, prevRule,self.getRelation())
            elif label != 'u':
                if label is None:
                    self.printInfo('label is none'+ rule,5)
                    self.printInfo(fragment,5)
                (pattern, score, matchingA, matchingI) = self.getPatternScoreAndMatching(dbNumA, dbNumI, fragment, label, prevRule)
            else :
                (pattern, score, matchingA, matchingI) = self.getPatternScoreAndMatching(dbNumA, dbNumI, fragment, label, prevRule)
               
                

            if pattern:
                if len(matchingLA) < len(fragments):
                    # has been a lengthening have to append
                    #self.printInfo('lengthening'
                    matchingLA.append(matchingA)
                    matchingLI.append(matchingI)
                    patterns.append(pattern)
                else:
                    # has been traversal, have to replace 
                    #self.printInfo("traversal (%s = %s)" % (len(matchingLA) , len(fragments))
                    matchingLA[lastElement] = matchingA
                    matchingLI[lastElement] = matchingI 
                    patterns[lastElement]   = pattern
                

                matchingA = matchingLA[0]
                matchingI = matchingLI[0]
                for i in range(len(matchingLA)-1):
                    matchingA = li.intersection(matchingA, matchingLA[i+1])
                    matchingI = li.intersection(matchingI, matchingLI[i+1])

                matcher = self.getMatcher()


                #score = self.compute_v(len(matchingA), len(matchingI), matcher.getNumEntries(dbNumA,1), matcher.getNumEntries(dbNumI,1))
                #print "scoreNewRules"
                if use_foil:
                    score = self.foil_gain(matchingA, matchingI, prevRule['matchingA'], prevRule['matchingI'])
                else:
                    score = self.calculateHeuristic(len(matchingA), len(matchingI), matcher.getNumEntries(dbNumA,1), matcher.getNumEntries(dbNumI,1))
                    
                rule['score']     = score
                rule['matchingA'] = matchingA
                rule['matchingI'] = matchingI
                rule['matchingLA'] = matchingLA
                rule['matchingLI'] = matchingLI
                rule['patterns'] = patterns

                scoredRules.append(rule)
                
        return scoredRules
            
 ################################               
            
            

    def getNextRefinementType(self, curType, curSubType):
        refinementSubTypes = {'a':['ab','ac'], 'b':['ba'], 'c':['ca']}
        returnType = None

        if refinementSubTypes.has_key(curType):
            subTypes = refinementSubTypes[curType]
            cur = None
            try:
                cur = subTypes.index(curSubType)
                if cur+1 < len(subTypes):
                    returnType = subTypes[cur+1]
            except Exception, e:
                returnType = subTypes[0]
                pass

        return returnType




    # scores a fragment string according to i_gain
    # returnMode either 0: score only, or 1 (score, matchingA, matchingI)
    def scoreFragmentString(self, dbNumA, dbNumI, fragmentString, prevMatchingLA, prevMatchingLI, returnMode=0):
        if fragmentString:
            #print fragmentString
            matcher = self.getMatcher()
            matchingLA = matcher.getMatching(dbNumA, fragmentString,1,1)
            matchingLI = matcher.getMatching(dbNumI, fragmentString,1,1)
            #            score = self.compute_v(len(matchingLA), len(matchingLI), matcher.getNumEntries(dbNumA,1), matcher.getNumEntries(dbNumI,1))
            #self.printInfo(len(prevMatchingLA), len(prevMatchingLI), fragmentString
            #self.printInfo(len(matchingLA), len(matchingLI), fragmentString
            #print "scoreFragmentString"
            score = self.foil_gain(matchingLA, matchingLI, prevMatchingLA, prevMatchingLI)
            if returnMode:
                return (score,matchingLA, matchingLI)
            else:
                return score
        else:
            if returnMode:
                return (-1000,[], [])
            else:
                return -10000

    def scoreBinCondition(self, matchingLA, matchingLI, prevMatchingLA, prevMatchingLI, returnMode=0):
        #print  matchingLA, matchingLI, prevMatchingLA, prevMatchingLI
        #print "scoreBinCondition"
        score = self.foil_gain(matchingLA, matchingLI, prevMatchingLA, prevMatchingLI)
        if returnMode:
            return (score,matchingLA, matchingLI)
        else:
            return score
        
    def scoreRuleFromPrunning(self,dbNumA, dbNumI, rule):
        if rule:

            li = Lists()
            
            for i in range(len(rule['patterns'])):
                (localScore, localMatchingA, localMatchingI) = (None,None,None)
                if not rule['numerical'][i]:
                    (localScore, localMatchingA, localMatchingI) = self.scoreRuleFragmentFromPrunning(dbNumA, dbNumI, rule['patterns'][i],1)
                else:
                    #print 'SCORE NUMERICAL'
                    (localScore, localMatchingA, localMatchingI) = self.scoreRuleBinFromPrunning(dbNumA, dbNumI, rule['patterns'][i],1)
                    
                rule['matchingLA'][i] = localMatchingA
                rule['matchingLI'][i] = localMatchingI

            matchingA = rule['matchingLA'][0]
            matchingI = rule['matchingLI'][0]

            for i in range(len(rule['patterns'])-1):
                matchingA = li.intersection(matchingA,rule['matchingLA'][i+1]) 
                matchingI = li.intersection(matchingI,rule['matchingLI'][i+1])

            rule['matchingA'] = matchingA
            rule['matchingI'] = matchingI

            matcher = self.getMatcher()
            Pos = self.getMatcher().getCurrentMatchSet(dbNumA)
            Neg = self.getMatcher().getCurrentMatchSet(dbNumI)
            #score = self.compute_v(len(matchingA),len(matchingI) , len(Pos), len(Neg))
            #print "scoreRulesFromPrunning"
            score = self.calculateHeuristic(len(matchingA),len(matchingI) , len(Pos), len(Neg))
            rule['score'] = score


    def scoreRuleFragmentFromPrunning(self, dbNumA, dbNumI, fragmentString, returnMode=1):
        matcher = self.getMatcher()
        returnValue = None

        if fragmentString:
            pos = self.getMatcher().getMatching(dbNumA, fragmentString,1)
            neg = self.getMatcher().getMatching(dbNumI, fragmentString,1)
            Pos = self.getMatcher().getCurrentMatchSet(dbNumA)
            Neg = self.getMatcher().getCurrentMatchSet(dbNumI)
            #score = self.compute_v(len(pos),len(neg) , len(Pos), len(Neg))
            #print "scoreRuleFragmentFromPrunning"
            score = self.calculateHeuristic(len(pos),len(neg) , len(Pos), len(Neg))
            if returnMode:
                return (score, pos, neg)
            else:
                return score

    def scoreRuleBinFromPrunning(self, dbNumA, dbNumI, fragmentString, returnMode=1):
        matcher = self.getMatcher()
        returnValue = None

        if fragmentString:
            relation = self.getRelation()
            #print fragmentString, 
            label = fragmentString[:fragmentString.index(' ')]
            condition = fragmentString.replace(label,'#X#')
            Pos = self.getMatcher().getCurrentMatchSet(dbNumA)
            Neg = self.getMatcher().getCurrentMatchSet(dbNumI)

            activesInt = []
            inactivesInt = []
        
            #akprint "\nscoreRuleBinFromPrunning"
            #potActiveInt = relation.getValues(attribute=label,id = Pos, internalId='active')
            #potInactiveInt = relation.getValues(attribute=label,id = Neg, internalId='inactive')

            potActiveInt = relation.getBalues(attribute=label,ids = Pos, internalId='active')
            potInactiveInt = relation.getBalues(attribute=label,ids = Neg, internalId='inactive')
            g  = condition.find('>')
            le = condition.find('<=')
            if g>0:
                value = string.atof(condition[g+1:])
                activesInt = filter(lambda x: potActiveInt[x][label] > value,potActiveInt.keys()) 
                inactivesInt = filter(lambda x: potInactiveInt[x][label] > value,potInactiveInt.keys()) 
            elif le>0:
                value = string.atof(condition[le+2:])
                activesInt = filter(lambda x: potActiveInt[x][label] <= value,potActiveInt.keys()) 
                inactivesInt = filter(lambda x: potInactiveInt[x][label] <= value,potInactiveInt.keys()) 
            else:
                raise "errorssssss"
                
            pos = []
            if activesInt:
                pos = relation.convertToSmipperID('active',activesInt)

            neg = []
            if inactivesInt:
                neg = relation.convertToSmipperID('inactive',inactivesInt)

            #pos = self.getMatcher().getMatching(dbNumA, fragmentString,1)
            #neg = self.getMatcher().getMatching(dbNumI, fragmentString,1)
            #score = self.compute_v(len(pos),len(neg) , len(Pos), len(Neg))
            #print "scoreRuleBinFromPrunning"
            score = self.calculateHeuristic(len(pos),len(neg) , len(Pos), len(Neg))
            if returnMode:
                return (score, pos, neg)
            else:
                return score
              
        


        
            

            
        
    
class reHelper:

    aBracket = re.compile('[\(|\)]')
    anOpenBracket = re.compile('\(')
    aCloseBracket = re.compile('\)')

    def getNumBrackets(self, aString):
        matchO = len(self.anOpenBracket.findall(aString))
        matchC = len(self.aCloseBracket.findall(aString))
        return (matchO, matchC)

    def removeTrailing(self, aString):
        all = match = self.aBracket.findall(aString)
        if all and all[len(all)-1] == '(':
            location = aString.rindex('(')
            workString = aString[:location]
            if location < len(aString):
                workString = workString + aString[location+1:]
            return self.removeTrailing(workString)
        return aString
        
    def removeLeading(self,aString):
        pos = None
        match = self.aBracket.search(aString)
        if match:
            return aString[:match.start()]+aString[match.end():]
        return aString

    def isUnbalanced(self, aString):
        if aString.count('(') != aString.count(')'): # unbalanced !!
            return 1
        else:
            match = self.aBracket.search(aString)
            if match and match.group() == ')':
                return 1
        return None

    def splitBrackets1(self, aString, once=None):
        retString = aString 
        matchO = self.anOpenBracket.search(aString)
        matchC = self.aCloseBracket.search(aString)

        if matchO is None:
            #self.printInfo('splitBrackets1_1'
            return aString
        elif matchO and matchC:
            #self.printInfo('splitBrackets1_2'
            if matchC.start() < matchO.start(): # string begins with an closing bracket
                print "reHelper !!!!!!!!error"
                return None
            else:
                #self.printInfo('splitBrackets1_3'
                count = 0
                offset = 0
                matchPos = matchO.start()
                matchPosStart = matchPos
                count += 1
                #self.printInfo(matchPos
                while(matchPos<len(aString)):
                    matchOpen  = -1
                    matchClose = -1
                    try:
                        matchClose = aString[matchPos+1:].index(')')
                        #matchCloseT = self.anOpenBracket.search(aString[matchPos+1:]).start()
                        #self.printInfo('matchClose',matchClose
                    except:
                        pass
                    try:
                        matchOpen  = aString[matchPos+1:].index('(')
                        #matchOpenT  = self.aCloseBracket.search(aString[matchPos+1:]).start()
                        #self.printInfo('matchOpen',matchOpen
                    except:
                        pass

                    #self.printInfo('------\n'
                    if matchClose < 0:
                        #self.printInfo('splitBrackets1_3_1'
                        if once:   # HACK for missing closing bracket at the end - will have to be removed!!!!!!!
                            #self.printInfo("Error finding closing bracket (input was %s)" % aString,5)
                            print "reHelper Error finding closing bracket (input was %s)" % aString
                            return self.splitBrackets1(aString+')', 'once')
                        else:
                            return self.splitBrackets1(self.removeLeading(aString))
                            #return None
                    elif matchOpen < 0: # there are no further opening brackets...
                        #self.printInfo('splitBrackets1_3_2'
                        count -= 1
                        if count == 0: # was closing bracket , can return string
                            return (aString[:matchPosStart], aString[matchPosStart+1:matchPos+matchClose+1], aString[matchPos+matchClose+2:])
                        else:
                            matchPos = matchPos+matchClose+1
                    elif matchClose < matchOpen: # was a closing bracket
                        #self.printInfo('splitBrackets1_3_3'
                        count -= 1
                        if count == 0: # was closing bracket , can return string
                            return (aString[:matchPosStart], aString[matchPosStart+1:matchPos+matchClose+1], aString[matchPos+matchClose+2:])
                        else:
                            matchPos = matchPos+matchClose+1
                    else: # found an opening bracket before the closing one
                        #self.printInfo('splitBrackets1_3_4'
                        count += 1
                        matchPos = matchPos+matchOpen+1
                
        return retString
        

    def splitBrackets(self, aString, once=None):

#        if aString.count('(') != aString.count(')'): # unbalanced !!
#            sys.stderr.write('unabalanced brackets!\n')
#            return None

        count = 0
        offset = 0
        try:
            matchPos = aString.index('(')
            matchPosStart = matchPos
            count += 1
        except:
#            self.printInfo("errorS"
            matchPos = len(aString)+1
            pass

#        self.printInfo(matchPos
        while(matchPos<=len(aString)):
            matchOpen  = -1
            matchClose = -1
            try:
                matchClose = aString[matchPos+1:].index(')')
            except:
                pass
            try:
                matchOpen  = aString[matchPos+1:].index('(')
            except:
                pass


            if matchClose < 0:
#                self.printInfo('matchClose < 0; matchOpen = %s' % matchOpen
                if once:   # HACK for missing closing bracket at the end - will have to be removed!!!!!!!
                    self.printInfo("Error finding closing bracket (input was %s)" % aString,5)
                    self.splitBrackets(aString+')', 'once')
                else:
                    return None
            elif matchOpen < 0: # there are no further opening brackets...
#                self.printInfo('matchOpen < 0; matchClose = %s' % matchClose
                count -= 1
                if count == 0: # was closing bracket , can return string
                    return (aString[:matchPosStart], aString[matchPosStart+1:matchPos+matchClose+1], aString[matchPos+matchClose+2:])
                else:
                    matchPos = matchPos+matchClose+1
            elif matchClose < matchOpen: # was a closing bracket
#                self.printInfo('matchClose < matchOpen;  %s < %s' % (matchClose, matchOpen)
                count -= 1
                if count == 0: # was closing bracket , can return string
                    return (aString[:matchPosStart], aString[matchPosStart+1:matchPos+matchClose+1], aString[matchPos+matchClose+2:])
                else:
                    matchPos = matchPos+matchClose+1
            else: # found an opening bracket before the closing one
#                self.printInfo('matchClose > matchOpen;  %s > %s' % (matchClose, matchOpen)
                count += 1
                matchPos = matchPos+matchOpen+1
#            if count > 2000:
#                return retString
                
        return retString
        

    # terrible but true
    def getDoubles(self, aList): 
        retList = []
        for item in aList:
            if aList.count(item)>=2 and item not in retList:
                retList.append(item)

        return retList

    def getUniques(self, aList):
        retList = []
        for item in aList:
            if aList.count(item)==1:
                retList.append(item)
        return retList

    def getIntersection(self, aList, bList):
        retList = []
        for item in aList:
            if item in bList:
                retList.append(item)
        return retList
           

  
def usage(smirep):
    print "\n\nUsage for %s" % sys.argv[0]
    lenName = len(sys.argv[0])
    print "----------"+lenName*'-'+"\n"
    print"Options:"
    print "--------"
    print "-%s\t--%s\t\t\t:\t%s" % ('h','help','Produces this help output')
    print "-%s\t--%s\t\t\t:\t%s" % ('m','mode','Either learn and test (lt), k-fold cross validation (cv), or leave-one-out (loo). Default is k=10-fold \n\t\t\t\t\tcross validation. For learn and test, the options active_test and inactive_test have to be set.')
    print "-%s\t--%s\t\t\t:\t%s" % ('s','seeds','Specifies the number of seeds to be used for learning. The default is 10.')
    print "-%s\t--%s\t\t:\t%s" % ('o','output','Specifies the output file for thefound rules.')
    print "-%s\t--%s\t\t:\t%s" % ('v','verbose','Sets the output to verbose. This is the same as setting the verbosity level to 1')
    print "-%s\t--%s\t:\t%s" % ('V','verbosity_level','Specifies the verbosity level. The verbosity level is : 0:no output, 1: found rules, 2:trace')
    print "-%s\t--%s\t\t\t:\t%s" % ('F','input','Specifies the ARFF file containing active and inactive examples (excludes the use of SMI files)')
    print "-%s\t--%s\t\t:\t%s" % ('T','inputT','Specifies the ARFF file containing active and inactive examples for testing (mode == lt) ')
    print "-%s\t--%s\t\t:\t%s" % ('a','active','Specifies the training database for the active compounds')
    print "-%s\t--%s\t\t:\t%s" % ('i','inactive','Specifies the training database for the inactive compounds')
    print "-%s\t--%s\t\t:\t%s" % ('A','active_test','Specifies the testing database for the active compounds. Required is mode=lt')
    print "-%s\t--%s\t\t:\t%s" % ('I','inactive_test','Specifies the testing database for the inactive compounds. Required is mode=lt')
    print "-%s\t--%s\t\t:\t%s" % ('t','stopping_rate','Specifies a user defined error rate for stopping learning. The default is the percentage of active compounds. Default = 100*pos/(all)')
    print "-%s\t--%s\t\t:\t%s" % ('p','min_pos','min_pos')
    print "-%s\t--%s\t\t:\t%s" % ('n','max_neg','NOT USED')
    print "-%s\t--%s\t\t\t:\t%s" % ('b','beam','The beam size used while searching (default 10)')
    print "-%s\t--%s\t\t:\t%s" % ('z','bin_size','The size for bins (only used if numeric attributes are present and data is supplied in ARFF (default 5)')
    print "-%s\t--%s\t:\t%s" % ('D','rule_directory','Specifies the directory where the found rules should be saved (optional)')
    print "-%s\t--%s\t\t:\t%s" % ('r','roc_out','Specifies the directory and file name (start) for ROC curves. The suffix will be appended automatically')
    print "-%s\t--%s\t\t:\t%s" % ('e','heuristic','Specifies the heuritic to use during search. Default = compute_v')
    print "\t\t\t\t\tAvailable heuristics are %s" % (smirep.getAvailableHeuristics())
    print "\n"
    
def message(msgs):
    conflict = 'conflict has'
    if len(msgs) > 1:
        conflict = 'conficts have'
        
    print "The following %s occured:\n" % conflict
    msgCount = 0
    for msg in msgs:
        msgCount += 1
        print "%2d\t%s" % (msgCount,msg)
    print "\n"
 
    
def main():
    # generate it here, we are able to require about available heuristics
    matcher = Matcher()
    smirep = SMIREP(matcher)

    try:
        opts, args = getopt.getopt(sys.argv[1:], "hm:k:s:b:o:vV:F:T:a:i:A:I:r:D:e:t:p:n:z:", ["help","mode=","k=", "seeds=","beam=","output=","verbose","verbosity_level=","input=", "inputT=", "active=","inactive=","active_test=","inactive_test=", "roc_out=", "rule_directory=", 'heuristic=', 'stopping_rate=','min_pos=', 'max_neg=', 'bin_size='])
    except getopt.GetoptError:
        # print help information and exit:
        usage(smirep)
        sys.exit(2)

    help            = None
    mode            = 'cv'
    k               = 10
    seeds           = 10
    beam            = 10
    in_file_tr      = ''
    in_file_te      = ''
    db_a_tr         = ''
    db_i_tr         = ''
    db_a_te         = ''
    db_i_te         = ''
    verbose         = False
    verbosity_level = 0
    output          = ''
    rocOut          = None
    ruleDirectory   = None
    heuristic       = None;
    stopping_rate   = None
    minPos          = 5;
    maxNeg          = None;
    binSize         = 5;

    messages = []

   
    for o, a in opts:
        print "o = '%s'\ta = '%s'" % (o,a)
        if o in ("-h", "--help"):
            usage(smirep)
            sys.exit(2)
        if o in ("-m", "--mode"):
            mode = a
            print a
        if o in ("-s", "--seeds"):
            if a.isdigit():
                seeds = string.atoi(a)
            else:
                messages.append("Seeds have to be an integer")
        if o in ("-k", "--k"):
            if a.isdigit():
                k = string.atoi(a)
            else:
                messages.append("k has to be an integer")
        if o in ("-b", "--beam"):
            if a.isdigit():
                beam = string.atoi(a)
            else:
                messages.append("The beam size has to be an integer")
        if o in ("-o", "--output"):
            output = a
        if o in ("-v", "--verbose"):
            verbose = True
        if o in ("-V", "--verbosity_level"):
            if a.isdigit():
                verbosity_level = string.atoi(a)
            else:
                messages.append("The verbosity level has to be an integer")
        if o in ("-F", "--input"):
           in_file_tr = a
        if o in ("-T", "--inputT"):
            in_file_te = a
        if o in ("-a", "--active"):
            db_a_tr= a
        if o in ("-i", "--inactive"):
            db_i_tr= a
        if o in ("-A", "--active_test"):
           db_a_te = a
        if o in ("-I", "--inactive_test"):
           db_i_te = a
        if o in ("-r", "--roc_out"):
           rocOut = a
        if o in ("-D", "--rule_directory"):
           ruleDirectory = a
        if o in ("-e", "--heuristic"):
           heuristic = a
        if o in ("-t", "--stopping_rate"):
            isNumber = None
            try:
                isNumber = string.atof(a)
            except:
                pass
            if isNumber:
                stopping_rate = isNumber 
            else:
                messages.append("The stopping rate has to be a float")
        if o in ("-p", "--min_pos"):
            if a.isdigit():
                minPos = string.atoi(a)
            else:
                messages.append("Min. positives has to be an integer")
        if o in ("-n", "--max_neg"):
            if a.isdigit():
                maxNeg = string.atoi(a)
            else:
                messages.append("Max. negatives has to be an integer")
                
        if o in ("-z", "--bin_size"):
            if a.isdigit():
                binSize = string.atoi(a)
            else:
                messages.append("BinSize has to be a positive integer")
                

    

    # check dependencies

    if in_file_tr:
        print "in_file_tr"
        if not os.access(in_file_tr, os.R_OK):
            messages.append("The input file for training examples cannot be read." )
        (db_a_tr, db_i_tr) = (in_file_tr,'arff')
        print "in_file_tr"
    if not db_a_tr and not in_file_tr:
        print "not db_a_tr and not in_file_tr"
        messages.append("The training DB for active compounds has to be specified." )
    elif not os.access(db_a_tr, os.R_OK) and not in_file_tr:
        print "not os.access(db_a_tr, os.R_OK) and not in_file_tr"
        messages.append("The training DB (%s) for active compounds cannot be read" % (db_a_tr))
    if not db_i_tr and not in_file_tr:
        print ""
        messages.append("The training DB for inactive compounds has to be specified." )
    elif not os.access(db_i_tr, os.R_OK) and not in_file_tr:
        print "not os.access(db_i_tr, os.R_OK) and not in_file_tr"
        messages.append("The training DB (%s) for inactive compounds cannot be read" % (db_i_tr))
    if (mode=='lt'):
        print "mode=='lt"
        if in_file_te:
            print "mode=='lt:%s" % in_file_te
            if not os.access(in_file_te, os.R_OK):
                print "mode=='lt:not os.access(in_file_te, os.R_OK)"
                messages.append("The input file for testing examples cannot be read." )
            (db_a_te, db_i_te) = (in_file_te,'arff')
        if not db_a_te and not in_file_te:
            print "mode=='lt:not db_a_te and not in_file_te"
            messages.append("The testing DB for active compounds has to be specified (mode=lt)." )
        elif not os.access(db_a_te, os.R_OK) and not in_file_te:
            print "mode=='lt:"
            messages.append("The testing DB (%s) for active compounds cannot be read" % (db_a_te))
        if not db_i_te and not in_file_te:
            print "mode=='lt:"
            messages.append("The testing DB for inactive compounds has to be specified (mode=lt)." )
        elif not os.access(db_i_te, os.R_OK) and not in_file_te:
            print "mode=='lt:"
            messages.append("The testing DB (%s) for inactive compounds cannot be read" % (db_i_te))
    if output:
        (path,filename) = os.path.split(output)
        # cannot write to that directory
        if not os.access(path, os.W_OK):
            os.mkdir(path)
            if not os.access(path, os.W_OK):
                messages.append("Cannot write to directory %s" % (output))
        # if output exist, check if we can write 
        elif os.path.exists(output):
            # the outputfilename is a directory
            if os.path.isdir(output):
                messages.append("Cannot write to a directory %s" % (output))
            elif not os.access(output, os.W_OK):
                messages.append("Cannot write to the output file (%s)" % (output))
                
                
               
            

    if verbose:
        verbosity_level = 1

    if verbosity_level:
        smirep.setVerbosityLevel(verbosity_level)

    if messages:
        usage(smirep)
        message(messages)
        sys.exit(-1)
        
    if (heuristic):
        if smirep.hasHeuristic(heuristic):
            smirep.selectHeuristic(heuristic)
        else:
            smirep.selectHeuristic('compute_v')
    else:
        smirep.selectHeuristic('compute_v')

    # set the bin size for numerical attributes
    if binSize:
        smirep.setBinSize(binSize)

    if output:
        smirep.openOutputFile(output)
        
    if (ruleDirectory):
        smirep.setRuleDirectory(ruleDirectory)
    if (rocOut):
        smirep.setRocFile(rocOut)


    print 'mode = %s' % mode

    if (mode=='cv'):
        smirep.IREP_k_fold(db_a_tr, db_i_tr, minPos=minPos, maxNeg=maxNeg, k=k, numSeeds=seeds, maxErrorRate=stopping_rate, beamSize=beam)
    elif (mode=='lt'):
        print "Starting learn and test %s\t%s" % (db_a_te, db_i_te)
        smirep.IREP_TestSet(db_a_tr, db_i_tr, db_a_te, db_i_te, minPos=minPos, maxNeg=maxNeg, numSeeds=seeds, maxErrorRate=stopping_rate, beamSize=beam)
    elif (mode=='loo'):
        smirep.IREP_leaveOneOut(db_a_tr, db_i_tr, minPos=minPos, maxNeg=maxNeg, numSeeds=seeds, maxErrorRate=stopping_rate, beamSize=beam)
   
    if output:
        smirep.closeOutputFile()
       

    
    sys.exit(0)


if __name__=='__main__':

    main()
    #profile.run('main()')
    sys.exit(0)
    matcher = Matcher()
    #dbFileNameA = './test/molecules_a.smi'
    #dbFileNameI = './test/molecules_m.smi'
    #dbFileNameI = './test/molecules_i.smi'
    #dbFileNameA = './test/mutagKramer/mutag_smiles_pos.smi'
    #dbFileNameI = './test/mutagKramer/mutag_smiles_neg.smi'
    #dbFileNameA = './test/davide/davide_smiles_pos.smi'
    #dbFileNameI = './test/davide/davide_smiles_neg.smi'
    dbFileNameA = './test/ntp/smiles_fr_pos.smi'
    dbFileNameI = './test/ntp/smiles_fr_neg.smi'
    dbFileNameAT = './test/fda/fda_smiles_fr_pos.smi'
    dbFileNameIT = './test/fda/fda_smiles_fr_neg.smi'

    
    smirep = SMIREP(matcher)
    #smirep.setMinPos(2)
    #smirep.IREP_TestSet(dbFileNameA, dbFileNameI, dbFileNameAT, dbFileNameIT, numSeeds=15, maxErrorRate=54.0)
    smirep.IREP_k_fold(dbFileNameA, dbFileNameI, k=10, numSeeds=10, maxErrorRate=56.0)
  
    sys.exit(0)
